;; $Header: /ctcvs/hclroot/src/koy/koycoll.ctl,v 1.2 2003/11/10 16:19:50 mevan Exp $
;*****************************************************************************
;*   Licensed Materials - Property of IBM
;*   5724-B96
;*
;*   Copyright IBM Corp. 2005 All Rights Reserved
;*   US Government Users Restricted Rights - Use, duplication or
;*   disclosure restricted by GSA ADP Schedule Contract with
;*   IBM Corp
;******************************************************************************
;;
cursor KOYV;
       virtual;
       INSERT INTO KOYV
             (DBNAME,                OSPROCID,              STOPTIME,
              STARTTIME,             NCPU,                  DBHOME,
              APPCPUPCT,             AVGBLOCKTM,            COLSTATUS,
              LAGSRVCPU,             CURINTVL,              CURLOCKS,
              CURRINTL,              DATACHSZ,              DBMWAIT,
              DBNAME,                DBTBLID,               DISKIO,
              ERRLOG,                ERRLOGSZ,              ERRORLOGSZ,
              ERRORID,               ERRORLOG,              INTVL,
              IOERRS,                IOERRSCURR,            IOERRSPCT,
              LASTERRAGE,            LOGONCURR,             LOGONMAX,
              LOGONPCT,              LOGONPSEC,             LOGTIME,
              MAXBLOCKTM,            MAXLOCKS,              MAXPROCESS,
              MAXSEV,                MAXSEVCURR,            MAXSEVTIME,
              MINDBFREE,             MINLOGFREE,            MSGAGE,
              MSGISSUER,             MSGTEXT1,              MSGTEXT2,
              MSGTIME,               NUMBAD,                NUMBLOCK,
              NUMCONFL,              NUMCURR,               NUMDBO,
              NUMDBS,                NUMERRORS,             NUMERRST,
              NUMINFECT,             NUMLOCKS,              NUMLOGSUS,
              NUMNOFRSP,             NUMOTH,                NUMPGSMB,
              NUMPROCESS,            NUMRO,                 NUMSEVG17,
              NUMSING,               NUMSLPLCK,             NUMSLPOTH,
              NUMSTOPPED,            ORIGINNODE,            OSTYPE,
              OSVERSN,               PCTCPUST,              PCTIO,
              PCTOSCPU,              PCTLOCKS,              PCTCPU,
              PGMWAIT,               PHYRDPSEC,             TXTPARM,
              SQLADDR,               MAXLOCK,               MAXBLOCK,
              TBMAXLOCK,             PCTBLOCK,
              PHYWRPSEC,             PROCCHSZ,              PROCCPCT,
              PROCCPU,               PROCCSZ,               SAMPLENO,
              SEVERITY,              SQLSTATE,              SRVAGE,
              SRVCPUPCT,             SRVSTARTT,             SRVSTATUS,
              SRVTYPE,               SRVVERSN,              HOLDSYSMON, TBMWAIT,
              TIMETICKS,             TMWAIT,                SYSTYPE1,
              SYSTYPE2,              SY10CSZ,               PROCCSZ,
              HOLDSTATUS,            HOLDSTATUS2,           HOLDSTATE,
              LOGONID,               PASSWORD,              SERVERID, VERSION,
              PMDESC,                PMVALUE,               UERRLOG,
              UMAXLOCK,              UMAXBLOCK,             UTBMXLOCK)
       VALUES
            (:DBNAME,               :OSPROCID,             :STOPTIME,
             :STARTTIME,            :NCPU,                 :DBHOME,
             :APPCPUPCT,            :AVGBLOCKTM,           :COLSTATUS,
             :LAGSRVCPU,            :CURINTVL,             :CURLOCKS,
             :CURRINTL,             :DATACHSZ,             :DBMWAIT,
             :DBNAME,               :DBTBLID,              :DISKIO,
             :ERRLOG,               :ERRLOGSZ,             :ERRORLOGSZ,
             :ERRORID,              :ERRORLOG,             :INTVL,
             :IOERRS,               :IOERRSCURR,           :IOERRSPCT,
             :LASTERRAGE,           :LOGONCURR,            :LOGONMAX,
             :LOGONPCT,             :LOGONPSEC,            :LOGTIME,
             :MAXBLOCKTM,           :MAXLOCKS,             :MAXPROCESS,
             :MAXSEV,               :MAXSEVCURR,           :MAXSEVTIME,
             :MINDBFREE,            :MINLOGFREE,           :MSGAGE,
             :MSGISSUER,            :MSGTEXT1,             :MSGTEXT2,
             :MSGTIME,              :NUMBAD,               :NUMBLOCK,
             :NUMCONFL,             :NUMCURR,              :NUMDBO,
             :NUMDBS,               :NUMERRORS,            :NUMERRST,
             :NUMINFECT,            :NUMLOCKS,             :NUMLOGSUS,
             :NUMNOFRSP,            :NUMOTH,               :NUMPGSMB,
             :NUMPROCESS,           :NUMRO,                :NUMSEVG17,
             :NUMSING,              :NUMSLPLCK,            :NUMSLPOTH,
             :NUMSTOPPED,           :ORIGINNODE,           :OSTYPE,
             :OSVERSN,              :PCTCPUST,             :PCTIO,
             :PCTOSCPU,             :PCTLOCKS,             :PCTCPU,
             :PGMWAIT,              :PHYRDPSEC,            :TXTPARM,
             :SQLADDR,              :MAXLOCK,              :MAXBLOCK,
             :TBMAXLOCK,            :PCTBLOCK,
             :PHYWRPSEC,            :PROCCHSZ,             :PROCCPCT,
             :PROCCPU,              :PROCCSZ,              :SAMPLENO,
             :SEVERITY,             :SQLSTATE,             :SRVAGE,
             :SRVCPUPCT,            :SRVSTARTT,            :SRVSTATUS,
             :SRVTYPE,              :SRVVERSN,             :HOLDSYSMON, :TBMWAIT,
             :TIMETICKS,            :TMWAIT,               :SYSTYPE1,
             :SYSTYPE2,             :SY10CSZ,              :PROCCSZ,
             :HOLDSTATUS,           :HOLDSTATUS2,          :HOLDSTATE,
             :LOGONID,              :PASSWORD,             :SERVERID, :VERSION,
             :PMDESC,               :PMVALUE,              :UERRLOG,
             :UMAXLOCK,             :UMAXBLOCK,            :UTBMXLOCK);



cursor KOYSRVRE;
demand;
limit 1;
no_sql;

INSERT INTO KOYSRVRE
 (SERVERID,               HOSTNAME,
  PCTLOCKS,                 PCTCPU,                 PCTOSCPU,
  SRVAGE,                   SRVVERSN,               NUMDBS,
  MINDBFREE,                MINLOGFREE,             NUMLOCKS,
  NUMCONFL,                 MAXLOCK,                MAXBLOCK,
  TBMAXLOCK,                PCTBLOCK,               MAXBLOCKTM,
  AVGBLOCKTM,               SRVCPUPCT,              APPCPUPCT,
  NUMPROCESS,               NUMBLOCK,               LASTERRAGE,
  MAXSEV,                   MAXSEVTIME,             NUMSEVG17,
  ERRLOGSZ,                 LOGONCURR,              LOGONPCT,
  PHYRDPSEC,                PHYWRPSEC,              IOERRSCURR,
  SRVSTATUS,                COLSTATUS,
  SAMPTIME,                 UMAXLOCK,               UMAXBLOCK,
  UTBMXLOCK)
 VALUES
 (:%me^32,                :%machine,
  :INT!KOYV.PCTLOCKS,       :INT!KOYV.PCTCPU,       :INT!KOYV.PCTOSCPU,
  :INT!KOYV.SRVAGE,         :KOYV.SRVVERSN^8,       :INT!KOYV.NUMDBS,
  :INT!KOYV.MINDBFREE,      :INT!KOYV.MINLOGFREE,   :INT!KOYV.NUMLOCKS,
  :INT!KOYV.NUMCONFL,       :KOYV.MAXLOCK^32,       :KOYV.MAXBLOCK^32,
  :KOYV.TBMAXLOCK^32,       :INT!KOYV.PCTBLOCK,     :INT!KOYV.MAXBLOCKTM,
  :INT!KOYV.AVGBLOCKTM,     :INT!KOYV.SRVCPUPCT,    :INT!KOYV.APPCPUPCT,
  :INT!KOYV.NUMPROCESS,     :INT!KOYV.NUMBLOCK,     :INT!KOYV.LASTERRAGE,
  :KOYV.MAXSEV^4,           :KOYV.MAXSEVTIME^16,    :INT!KOYV.NUMSEVG17,
  :INT!KOYV.ERRORLOGSZ,     :INT!KOYV.LOGONCURR,    :INT!KOYV.LOGONPCT,
  :INT!KOYV.PHYRDPSEC,      :INT!KOYV.PHYWRPSEC,    :INT!KOYV.IOERRSCURR,
  :KOYV.SRVSTATUS^12,       :KOYV.COLSTATUS^12,
  :TS!%now_time,            :KOYV.UMAXLOCK^96,      :KOYV.UMAXBLOCK^96,
  :KOYV.UTBMXLOCK^96);

;;
;;-----------------------------------------------------------
;; Heartbeat cursors
;; stop all the other cursors if sybase is not up.
;; also reinitialize cursors and continue checking
;; for sybase until it is raised again.
;;-----------------------------------------------------------
;;

cursor HART;
  interval 600;
  once;
  limit 1;
  math decimal 0 noround INT01  (0);
  decode INT01 = 0, 'hold cursor start';
  no_sql;
 INSERT INTO HART
   (INT)
 VALUES
   (:INT01^20);
;;

cursor HART0;
  interval 60;
  empty;
  limit 1;
  math decimal 0 noround INT01 (0);
  math decimal 0 noround INT02 (0);
  no_sql;
  LOAD INT01 -> KOYV.HOLDSTATUS;
  LOAD INT02 -> KOYV.HOLDSTATUS2;

 INSERT INTO HART0
   (HOLDSTATUS, HOLDSTATUS2)
 VALUES
   (:INT01,    :INT02 );
;;
;;-----------------------------------------------------------
;; use external exit to determine if sybase is active
;;-----------------------------------------------------------
;;
cursor HART1;
  interval 60;
  empty;
  limit 1;

  math decimal 0 ACTIVE (1);
  decode ACTIVE = 1, 'Active';

  fetch_exit fetchx2;
  script koy##sql
   -logon [KOYV.LOGONID
;; -password [KOYV.PASSWORD
   -rdbms [KOYV.SERVERID
   1 " " sp_helpdb master;

  insert_select
     SELECT TMPWORD1, INT01, INT02, INT03
      FROM   ABCXYZ;

;; holdstatus =0 - yes - do hold, >0 no - got data so far.
 LOAD INT02 -> KOYV.HOLDSTATUS;
 LOAD ACTIVE -> KOYV.SRVSTATUS
       WHERE INT02 > 0;
 INSERT INTO HART1
   ( TMPWORD1, INT01, INT02,
     HOLDSTATUS,ACTIVE )
 VALUES
   ( :TMPWORD1^16, :INT!INT01, :INT!INT02,
     :INT!KOYV.HOLDSTATUS,:ACTIVE );
;;
;;-----------------------------------------------------------
;;  is database accessable - SQL PORTION
;;   Try simple sql request to determine if we can access
;;   database from scripts.  Version number used later for
;;   System 11 check (SYSCHECK).
;;-----------------------------------------------------------
;;
cursor HART2;
  interval 60;
  empty;
  limit 1;

;; Solaris 11.0 on Solaris has a bug where by stuff(,,,NULL) always
;; returns a null string.   Coding around it.

  math decimal 0 noround VERSION ((SRVVERSN*10)/10); 

  insert_select
    select STATUS = 1,
         SRVVERSN = substring(@@version,1+charindex("/",@@version),
       charindex("/",stuff(@@version,1,charindex("/",@@version),"x"))-2);

 LOAD COUNT!STATUS  -> KOYV.HOLDSTATUS2;
 LOAD SRVVERSN      -> KOYV.SRVVERSN;
 LOAD VERSION       -> KOYV.VERSION;

 INSERT INTO HART2
  (  STATUS,  SRVVERSN, VERSION, XXX )
 VALUES
  ( :STATUS, :SRVVERSN, :VERSION, :%SQLCODE_HART2 );

;;
;;-----------------------------------------------------------
;;   set koyv.holdstatus to 1 if both hart1 and hart2
;;   returned proper values.  set holdstatus to 0 if
;;   either of the cursors did not run properly.
;;-----------------------------------------------------------
;;
cursor HART3;
  interval 60;
  empty;
  limit 1;

;;    reverse 0/non-0 return code. 1=good, 0=bad.
  math decimal 0 noround INT02 (KOYV.HOLDSTATUS);
  decode INT02 = 0, 0;
  decode INT02 default 1;
  math decimal 0 noround INT03  (KOYV.HOLDSTATUS2);
  decode INT03 = 0, 0;
  decode INT03 default 1;

  no_sql;

  LOAD INT02 ->   KOYV.HOLDSTATUS;


  LOAD INT03  ->   KOYV.HOLDSTATUS
                    WHERE INT03 = 0;

  INSERT INTO HART3
    (XXXX,          HOLDSTATUS, HOLDSTATUS2 )
  VALUES
    (:%SQLCODE_HART2, :INT02, :INT03 );

;;-----------------------------------------------------------
;;  if holdstatus and holdstate are equal then there was
;;  no change in state so we just skip on by.
;;  Else, holdstatus tells us whether to hold all the
;;  rest of the cursors or to release them.
;;-----------------------------------------------------------
;;

;; if collector finds sybase is down, then shutdown this collector process
;;and restart a new collector process
cursor START;
  demand;
  fetch_exit fetchx2;
  script  restart.sh [KOYV.HOLDSTATE ;
  insert_select
     SELECT INT01 from ABCXYZ
    ;

 INSERT INTO START
   (A)
 VALUES
   (:INT01 );

cursor HART4;
  interval 60;
  empty;
  limit 1;
  math decimal 0 noround INT01  (KOYV.HOLDSTATE);
  math decimal 0 noround INT02  (KOYV.HOLDSTATUS);
  math decimal 0 noround INT03  (KOYV.HOLDSTATUS);
  decode INT02 = INT01, INT02;
  decode INT02 = 0  run START ;
  decode INT02 = 1, 'release below ';
;;  if START is held then hold below will stop the rest
  decode INT03 = INT01, INT03;
  decode INT03 = 0, 'hold below ' ;

  no_sql;

  LOAD INT02 ->  KOYV.HOLDSTATE;

 INSERT INTO HART4
   (HOLDSTATUS, HOLDSTATE, A)
 VALUES
   (:INT02, :INT01, :INT03 );
;;
cursor HART5;
  interval 6000;
  once;
  limit 1;
  math decimal 0 noround INT01  (KOYV.HOLDSTATE);
  decode INT01 = 1, 'release cursor start';
  no_sql;

 INSERT INTO HART5
   (HOLDSTATE )
 VALUES
   (:INT01^20);


;;-----------------------------------------------------------
;;  Get the server-specific information
;;-----------------------------------------------------------

cursor KOYVOSV;

       interval 99;
       once;
       limit 1;
       fetch_exit fetchx2;
       script kddos osv;

       LOAD OSTYPE                -> KOYV.OSTYPE;
       LOAD OSVERSN               -> KOYV.OSVERSN;

       insert_select
              SELECT OSTYPE,
                     OSVERSN
              FROM   ABCXYZ;

       INSERT INTO KOYVOSV
             (OSTYPE,                OSVERSN)
       VALUES
            (:OSTYPE,               :OSVERSN);

;;  note--this relies on a "once" cursor rerun each time the
;;  sybase server restarts

cursor SERVPID;
   once;
   limit 1;

   insert_select
      SELECT SRVSTARTT= convert(char(11),starttime,111)+convert(char(11),starttime,8)
      FROM   master..sysengines
      WHERE  engine = 0;

   LOAD SRVSTARTT -> KOYV.SRVSTARTT;

   INSERT INTO SERVPID
    (SRVSTARTT)
   VALUES
    (:SRVSTARTT);
 
cursor SETERRLG;
   once;
   limit 1;

   fetch_exit fetchx2;
   script koylog -dbhome [KOYV.DBHOME -rdbms [KOYV.SERVERID [KOYV.OSPROCID;

   insert_select
     SELECT ERRLOG, OSPROCID, TXTPARM
     FROM ABCXYZ;

   LOAD ERRLOG    -> KOYV.ERRLOG;
   LOAD OSPROCID  -> KOYV.OSPROCID;
   LOAD TXTPARM   -> KOYV.TXTPARM;

 INSERT INTO SETERRLG
   (ERRLOG,   OSPROCID,   TXTPARM)
 VALUES
 (:ERRLOG,   :OSPROCID,  :TXTPARM);

;;
;-------------------------------------------------------------------

;;
;;-----------------------------------------------------------
;;  if sybase is up, then we have the version number.
;;  We will disable System 11 cursors if the server is
;;  pre-System 11.
;;-----------------------------------------------------------
;;
cursor SYSCHECK;
  interval 99;
  once;
  limit 1;
  math decimal 0 noround INT01  (KOYV.SRVVERSN);
  decode INT01 < 11, 'hold cursor KOYMINIT
                                  SYSMON
                                  CACHEMAP';
  no_sql;

  INSERT INTO SYSCHECK
    (SRVVERSN)
  VALUES
    (:INT01^60);

cursor MINITCK;
  interval 86400;
  once;
  limit 1;
  math decimal 0 HOLDSYSMON  (KOYV.HOLDSYSMON);
  decode HOLDSYSMON < 1  run KOYMINIT ;

  no_sql;


  INSERT INTO MINITCK
    (HOLDSYSMON)
  VALUES
    (:INT!HOLDSYSMON);

;;
;;*********************************************
;;
;;     KOYMINIT - build system 11 sysmon
;;                temproary table and load
;;                stored procedures
;;
;;*********************************************

cursor KOYMINIT;

;;       interval 86400;
    demand;
    once;

    fetch_exit fetchx2;

    script koy##sql
      -logon [KOYV.LOGONID
;;    -password [KOYV.PASSWORD
      -rdbms [KOYV.SERVERID
      3 tempdb '
      dbcc monitor ("clear", "all", "on")

    select datepart(second,getdate())
        + (datepart(minute,getdate())*60)
        + (datepart(hour,getdate())*3600)
    ';

    insert_select
       SELECT STOPTIME
           FROM ABCXYZ;

    LOAD STOPTIME ->KOYV.STOPTIME;

    INSERT INTO KOYMINIT
    (STOPTIME)
    VALUES (:STOPTIME);
;;**********************************************************************
;;
;;    SYSMON (old name KOYMRUN) - drive system 11 sysmon dbcc process
;;
;;**********************************************************************

cursor STPSTRT;

    demand;
    no_sql;
    math decimal 0 noround INT01 (KOYV.STOPTIME);

    LOAD INT01 -> KOYV.STARTTIME;


    INSERT INTO STPSTRT
    (STARTTIME)
    VALUES
    (:INT01^20);


;;cursor KOYMRUN;
;;cursor SYSMON;
;;       interval 120;
;;       limit 3000;
;;       empty;
;;
;;       fetch_exit fetchx2;
;;       script koy##sql
;;        -logon [KOYV.LOGONID
;;        -password [KOYV.PASSWORD
;;            -rdbms [KOYV.SERVERID
;;            3 tempdb '
;;
;;declare @thistime int
;;
;;dbcc monitor("sample","all","off")
;;dbcc monitor("select","all","on")
;;dbcc traceon(8399)
;;;;
;;
;;select group_name,field_name,value from master..sysmonitors
;;
;;
;;select @thistime = datepart(second,getdate())
;;                 +(datepart(minute,getdate())*60)
;;                 +(datepart(hour,getdate())*3600)
;;
;;select "candle","stoptime",str(isnull(@thistime,0),12)
;;
;;dbcc monitor("clear","all","on")
;;';
;;
;;  pre_cursor STPSTRT;
;;
;;       insert_select
;;              SELECT GROUPNAME,
;;                     FLDNAME,
;;                     FLDVALUE
;;              FROM   ABCXYZ;
;;
;;
;;       LOAD FLDVALUE -> KOYV.STOPTIME;
;;
;;       INSERT INTO SYSMON
;;             (GROUPNAME,  FLDNAME,  FLDVALUE)
;;       VALUES
;;            (:GROUPNAME^35, :FLDNAME^25, :INT!FLDVALUE);

cursor DBCCON;
  interval 64000;
  once;

  math decimal 0 INT01 0;
  insert_select
     dbcc traceon(8399);

INSERT  INTO DBCCON
     (INT01)
   VALUES
     (:INT!INT01);

cursor SYSMONCK;
  interval 120;
  limit 1;

  math decimal 0 HOLDSYSMON (KOYV.HOLDSYSMON);
  decode  HOLDSYSMON < 1 run SYSMON;

  no_sql;

  INSERT  INTO SYSMONCK
     (HOLDSYSMON)
   VALUES
     (:INT!HOLDSYSMON);

cursor SYSMON;
;       interval 120;
       demand;
       limit 15000;
       empty;

insert_select

    dbcc monitor("sample","all","off")
    dbcc monitor("select","all","on")

    select GROUPNAME = group_name,
    FLDNAME    = field_name,
    FLDVALUE   = value
    from master..sysmonitors


    dbcc monitor("clear","all","on");


  pre_cursor STPSTRT;
  pre_cursor STOPT;

       INSERT INTO SYSMON
             (GROUPNAME,  FLDNAME,  FLDVALUE)
       VALUES
            (:GROUPNAME^35, :FLDNAME^25, :INT!FLDVALUE);


cursor STOPT;
  demand;
  limit 1;

    insert_select
    select STOPTIME =str(isnull( datepart(second,getdate())
                 +(datepart(minute,getdate())*60)
                 +(datepart(hour,getdate())*3600),0),12);

       LOAD STOPTIME  -> KOYV.STOPTIME;

       INSERT INTO STOPT
             (STOPTIME)
       VALUES
            (:INT!STOPTIME);

cursor CACHEMAP;

interval 6000;
once;

insert_select
     SELECT CACHENAME = name,
     BUFFERNAME =
        "buffer_"+ convert(varchar(2),config_admin(15,0,0,0,NULL,name))
       FROM master.dbo.sysconfigures
     WHERE  parent = 19
     AND    config = 19;

INSERT INTO CACHEMAP
      (CACHENAME, BUFFERNAME)
VALUES
      (:CACHENAME^30, :BUFFERNAME^30);



cursor SYSCCONF;

demand;
empty;

insert_select
;;     SELECT NUMENG = value
;;     FROM master.dbo.syscurconfigs
;;     WHERE config = 126;
     SELECT NUMENG = count(engine)
     FROM sysengines
     WHERE status = 'online';

INSERT INTO SYSCCONF
      (NUMENG)
VALUES
      (:INT!NUMENG);



cursor SYSDEV;

interval 6000;
once;

insert_select
  SELECT DEVNAME = name ,
  OSNAME = phyname ,
  DISKMON = "disk_"+ convert(varchar(4), low/16777216)
  FROM master.dbo.sysdevices
  WHERE (status &16) != 16
  ORDER BY phyname;

  INSERT INTO SYSDEV
       (DEVNAME , OSNAME ,DISKMON)
  VALUES
       (:DEVNAME^35, :OSNAME^76 ,:DISKMON^20);


cursor KOYENGD;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script i1
       KOYENGD;

       math decimal 0 INT01      INTERVAL;
       math decimal 0 INT02      NUM_XACTS;
       math decimal 0 INT03      CPU_AVAILABLE_PCT * 100;
       math decimal 0 INT04      CPU_BUSY_PCT * 100;
       math decimal 0 INT05      CPU_YIELDS_RATE * 100;
       math decimal 0 INT06      CPU_YIELDS_XACT * 100;
       math decimal 0 INT07      CPU_YIELDS_COUNT;
       math decimal 0 INT08      CPU_YIELDS_PCT * 100;
       math decimal 0 INT09      TASK_SWITCH_RATE * 100;
       math decimal 0 INT10      TASK_SWITCH_XACT * 100;
       math decimal 0 INT11      TASK_SWITCH_COUNT;
       math decimal 0 INT12      TASK_SWITCH_PCT * 100;
       math decimal 0 INT13      MAX_OUTSTANDING_IO_COUNT;
       math decimal 0 INT14      COMPLETED_DISK_IO_COUNT;
       math decimal 0 INT15      TDS_PACKETS_RECEIVED_RATE * 100;
       math decimal 0 INT16      TDS_PACKETS_RECEIVED_XACT * 100;
       math decimal 0 INT17      TDS_PACKETS_RECEIVED_COUNT;
       math decimal 0 INT18      TDS_PACKETS_RECEIVED_PCT * 100;
       math decimal 0 INT19      TDS_BYTES_RECEIVED_RATE * 100;
       math decimal 0 INT20      TDS_BYTES_RECEIVED_XACT * 100;
       math decimal 0 INT21      TDS_BYTES_RECEIVED_COUNT;
       math decimal 0 INT22      TDS_BYTES_RECEIVED_PCT * 100;
       math decimal 0 INT23      TDS_PACKETS_SENT_RATE * 100;
       math decimal 0 INT24      TDS_PACKETS_SENT_XACT * 100;
       math decimal 0 INT25      TDS_PACKETS_SENT_COUNT;
       math decimal 0 INT26      TDS_PACKETS_SENT_PCT * 100;
       math decimal 0 INT27      TDS_BYTES_SENT_RATE * 100;
       math decimal 0 INT28      TDS_BYTES_SENT_XACT * 100;
       math decimal 0 INT29      TDS_BYTES_SENT_COUNT;
       math decimal 0 INT30      TDS_BYTES_SENT_PCT * 100;

       pre_cursor SYSCCONF;

       insert_select
              SELECT ENGINE,
                     INTERVAL,
                     NUM_XACTS,
                     CPU_AVAILABLE_PCT,
                     CPU_BUSY_PCT,
                     CPU_YIELDS_RATE,
                     CPU_YIELDS_XACT,
                     CPU_YIELDS_COUNT,
                     CPU_YIELDS_PCT,
                     TASK_SWITCH_RATE,
                     TASK_SWITCH_XACT,
                     TASK_SWITCH_COUNT,
                     TASK_SWITCH_PCT,
                     MAX_OUTSTANDING_IO_COUNT,
                     COMPLETED_DISK_IO_COUNT,
                     TDS_PACKETS_RECEIVED_RATE,
                     TDS_PACKETS_RECEIVED_XACT,
                     TDS_PACKETS_RECEIVED_COUNT,
                     TDS_PACKETS_RECEIVED_PCT,
                     TDS_BYTES_RECEIVED_RATE,
                     TDS_BYTES_RECEIVED_XACT,
                     TDS_BYTES_RECEIVED_COUNT,
                     TDS_BYTES_RECEIVED_PCT,
                     TDS_PACKETS_SENT_RATE,
                     TDS_PACKETS_SENT_XACT,
                     TDS_PACKETS_SENT_COUNT,
                     TDS_PACKETS_SENT_PCT,
                     TDS_BYTES_SENT_RATE,
                     TDS_BYTES_SENT_XACT,
                     TDS_BYTES_SENT_COUNT,
                     TDS_BYTES_SENT_PCT
              FROM   ABCXYZ;

       INSERT INTO KOYENGD
             (
              SERVERID,                          HOSTNAME,
              ENGINE,                            INTERVAL,
              NUM_XACTS,                         CPU_AVAILABLE_PCT,
              CPU_BUSY_PCT,                      CPU_YIELDS_RATE,
              CPU_YIELDS_XACT,                   CPU_YIELDS_COUNT,
              CPU_YIELDS_PCT,                    TASK_SWITCH_RATE,
              TASK_SWITCH_XACT,                  TASK_SWITCH_COUNT,
              TASK_SWITCH_PCT,                   MAX_OUTSTANDING_IO_COUNT,
              COMPLETED_DISK_IO_COUNT,           TDS_PACKETS_RECEIVED_RATE,
              TDS_PACKETS_RECEIVED_XACT,         TDS_PACKETS_RECEIVED_COUNT,
              TDS_PACKETS_RECEIVED_PCT,          TDS_BYTES_RECEIVED_RATE,
              TDS_BYTES_RECEIVED_XACT,           TDS_BYTES_RECEIVED_COUNT,
              TDS_BYTES_RECEIVED_PCT,            TDS_PACKETS_SENT_RATE,
              TDS_PACKETS_SENT_XACT,             TDS_PACKETS_SENT_COUNT,
              TDS_PACKETS_SENT_PCT,              TDS_BYTES_SENT_RATE,
              TDS_BYTES_SENT_XACT,               TDS_BYTES_SENT_COUNT,
              TDS_BYTES_SENT_PCT,                SAMPTIME,
              UENGINE,
              ENGINE,                            INTERVAL,
              NUM_XACTS,                         CPU_AVAILABLE_PCT,
              CPU_BUSY_PCT,                      CPU_YIELDS_RATE,
              CPU_YIELDS_XACT,                   CPU_YIELDS_COUNT,
              CPU_YIELDS_PCT,                    TASK_SWITCH_RATE,
              TASK_SWITCH_XACT,                  TASK_SWITCH_COUNT,
              TASK_SWITCH_PCT,                   MAX_OUTSTANDING_IO_COUNT,
              COMPLETED_DISK_IO_COUNT,           TDS_PACKETS_RECEIVED_RATE,
              TDS_PACKETS_RECEIVED_XACT,         TDS_PACKETS_RECEIVED_COUNT,
              TDS_PACKETS_RECEIVED_PCT,          TDS_BYTES_RECEIVED_RATE,
              TDS_BYTES_RECEIVED_XACT,           TDS_BYTES_RECEIVED_COUNT,
              TDS_BYTES_RECEIVED_PCT,            TDS_PACKETS_SENT_RATE,
              TDS_PACKETS_SENT_XACT,             TDS_PACKETS_SENT_COUNT,
              TDS_PACKETS_SENT_PCT,              TDS_BYTES_SENT_RATE,
              TDS_BYTES_SENT_XACT,               TDS_BYTES_SENT_COUNT,
              TDS_BYTES_SENT_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :ENGINE,                           :INT!INT01,
             :INT!INT02,                        :INT!INT03,
             :INT!INT04,                        :INT!INT05,
             :INT!INT06,                        :INT!INT07,
             :INT!INT08,                        :INT!INT09,
             :INT!INT10,                        :INT!INT11,
             :INT!INT12,                        :INT!INT13,
             :INT!INT14,                        :INT!INT15,
             :INT!INT16,                        :INT!INT17,
             :INT!INT18,                        :INT!INT19,
             :INT!INT20,                        :INT!INT21,
             :INT!INT22,                        :INT!INT23,
             :INT!INT24,                        :INT!INT25,
             :INT!INT26,                        :INT!INT27,
             :INT!INT28,                        :INT!INT29,
             :INT!INT30                         :TS!%now_time,
             :ENGINE^90,
             :NS!ENGINE,                        :NS!INTERVAL,
             :NS!NUM_XACTS,                     :NS!CPU_AVAILABLE_PCT,
             :NS!CPU_BUSY_PCT,                  :NS!CPU_YIELDS_RATE,
             :NS!CPU_YIELDS_XACT,               :NS!CPU_YIELDS_COUNT,
             :NS!CPU_YIELDS_PCT,                :NS!TASK_SWITCH_RATE,
             :NS!TASK_SWITCH_XACT,              :NS!TASK_SWITCH_COUNT,
             :NS!TASK_SWITCH_PCT,               :NS!MAX_OUTSTANDING_IO_COUNT,
             :NS!COMPLETED_DISK_IO_COUNT,       :NS!TDS_PACKETS_RECEIVED_RATE,
             :NS!TDS_PACKETS_RECEIVED_XACT,     :NS!TDS_PACKETS_RECEIVED_COUNT,
             :NS!TDS_PACKETS_RECEIVED_PCT,      :NS!TDS_BYTES_RECEIVED_RATE,
             :NS!TDS_BYTES_RECEIVED_XACT,       :NS!TDS_BYTES_RECEIVED_COUNT,
             :NS!TDS_BYTES_RECEIVED_PCT,        :NS!TDS_PACKETS_SENT_RATE,
             :NS!TDS_PACKETS_SENT_XACT,         :NS!TDS_PACKETS_SENT_COUNT,
             :NS!TDS_PACKETS_SENT_PCT,          :NS!TDS_BYTES_SENT_RATE,
             :NS!TDS_BYTES_SENT_XACT,           :NS!TDS_BYTES_SENT_COUNT,
             :NS!TDS_BYTES_SENT_PCT);

;;**********************************************************************
;;
;;     KOYENGS - engine summary
;;
;;**********************************************************************

cursor KOYENGS;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script i1
           KOYENGS;

       pre_cursor SYSCCONF;
       math decimal 0 INT03      CPU_AVAILABLE_PCT * 100;
       math decimal 0 INT04      CPU_BUSY_PCT * 100;

       insert_select
       SELECT
              ENGINE,                            INTERVAL,
              NUM_XACTS,                         CPU_AVAILABLE_PCT,
              CPU_BUSY_PCT,                      CPU_YIELDS_COUNT,
              TASK_SWITCH_COUNT,                 MAX_OUTSTANDING_IO_COUNT,
              COMPLETED_DISK_IO_COUNT,           TDS_PACKETS_RECEIVED_COUNT,
              TDS_BYTES_RECEIVED_COUNT,          TDS_PACKETS_SENT_COUNT,
              TDS_BYTES_SENT_COUNT
       FROM   ABCXYZ;
       INSERT INTO KOYENGS
             (
              SERVERID,                          HOSTNAME,
              ENGINE,                            INTERVAL,
              NUM_XACTS,                         CPU_AVAILABLE_PCT,
              CPU_BUSY_PCT,                      CPU_YIELDS_COUNT,
              TASK_SWITCH_COUNT,                 MAX_OUTSTANDING_IO_COUNT,
              COMPLETED_DISK_IO_COUNT,           TDS_PACKETS_RECEIVED_COUNT,
              TDS_BYTES_RECEIVED_COUNT,          TDS_PACKETS_SENT_COUNT,
              TDS_BYTES_SENT_COUNT,              SAMPTIME,
              CPU_AVAILABLE_PCT,                 CPU_BUSY_PCT,
              UENGINE)
       VALUES
            (:%me^30,                       :%machine,
             :ENGINE,                       :INT!INTERVAL,
             :INT!NUM_XACTS,                :INT!INT03,
             :INT!INT04,                    :INT!CPU_YIELDS_COUNT,
             :INT!TASK_SWITCH_COUNT,        :INT!MAX_OUTSTANDING_IO_COUNT,
             :INT!COMPLETED_DISK_IO_COUNT,  :INT!TDS_PACKETS_RECEIVED_COUNT,
             :INT!TDS_BYTES_RECEIVED_COUNT, :INT!TDS_PACKETS_SENT_COUNT,
             :INT!TDS_BYTES_SENT_COUNT,     :TS!%now_time,
             :ENGINE^90,
             :NS!CPU_AVAILABLE_PCT,         :NS!CPU_BUSY_PCT);

;;**********************************************************************
;;
;;     KOYCACS - cache summary
;;
;;**********************************************************************

cursor KOYCACS;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script  i1
        KOYCACS;

       math decimal 0 INT01      CACHE_SRCH_RATE * 100;
       math decimal 0 INT02      CACHE_SRCH_XACT * 100;
       math decimal 0 INT03      CACHE_SRCH_COUNT;
       math decimal 0 INT04      CACHE_HIT_RATE * 100;
       math decimal 0 INT05      CACHE_HIT_XACT * 100;
       math decimal 0 INT06      CACHE_HIT_COUNT;
       math decimal 0 INT07      CACHE_HIT_PCT * 100;
       math decimal 0 INT08      CACHE_MISS_RATE * 100;
       math decimal 0 INT09      CACHE_MISS_XACT * 100;
       math decimal 0 INT10      CACHE_MISS_COUNT;
       math decimal 0 INT11      CACHE_MISS_PCT * 100;
       math decimal 0 INT12      LRU_BUFFERS_RATE * 100;
       math decimal 0 INT13      LRU_BUFFERS_XACT * 100;
       math decimal 0 INT14      LRU_BUFFERS_COUNT;
       math decimal 0 INT15      LRU_BUFFERS_PCT * 100;
       math decimal 0 INT16      MRU_BUFFERS_RATE * 100;
       math decimal 0 INT17      MRU_BUFFERS_XACT * 100;
       math decimal 0 INT18      MRU_BUFFERS_COUNT;
       math decimal 0 INT19      MRU_BUFFERS_PCT * 100;
       math decimal 0 INT20      LARGE_IO_PERFORMED_RATE * 100;
       math decimal 0 INT21      LARGE_IO_PERFORMED_XACT * 100;
       math decimal 0 INT22      LARGE_IO_PERFORMED_COUNT;
       math decimal 0 INT23      LARGE_IO_PERFORMED_PCT * 100;
       math decimal 0 INT24      LARGE_IO_DENIED_RATE * 100;
       math decimal 0 INT25      LARGE_IO_DENIED_XACT * 100;
       math decimal 0 INT26      LARGE_IO_DENIED_COUNT;
       math decimal 0 INT27      LARGE_IO_DENIED_PCT * 100;
       math decimal 0 INT28      LARGE_IO_CACHED_RATE * 100;
       math decimal 0 INT29      LARGE_IO_CACHED_XACT * 100;
       math decimal 0 INT30      LARGE_IO_CACHED_COUNT;
       math decimal 0 INT31      LARGE_IO_USED_RATE * 100;
       math decimal 0 INT32      LARGE_IO_USED_XACT * 100;
       math decimal 0 INT33      LARGE_IO_USED_COUNT;
       math decimal 0 INT34      LARGE_IO_USED_PCT * 100;

       insert_select
              SELECT CACHE_SRCH_RATE,
                     CACHE_SRCH_XACT,
                     CACHE_SRCH_COUNT,
                     CACHE_HIT_RATE,
                     CACHE_HIT_XACT,
                     CACHE_HIT_COUNT,
                     CACHE_HIT_PCT,
                     CACHE_MISS_RATE,
                     CACHE_MISS_XACT,
                     CACHE_MISS_COUNT,
                     CACHE_MISS_PCT,
                     LRU_BUFFERS_RATE,
                     LRU_BUFFERS_XACT,
                     LRU_BUFFERS_COUNT,
                     LRU_BUFFERS_PCT,
                     MRU_BUFFERS_RATE,
                     MRU_BUFFERS_XACT,
                     MRU_BUFFERS_COUNT,
                     MRU_BUFFERS_PCT,
                     LARGE_IO_PERFORMED_RATE,
                     LARGE_IO_PERFORMED_XACT,
                     LARGE_IO_PERFORMED_COUNT,
                     LARGE_IO_PERFORMED_PCT,
                     LARGE_IO_DENIED_RATE,
                     LARGE_IO_DENIED_XACT,
                     LARGE_IO_DENIED_COUNT,
                     LARGE_IO_DENIED_PCT,
                     LARGE_IO_CACHED_RATE,
                     LARGE_IO_CACHED_XACT,
                     LARGE_IO_CACHED_COUNT,
                     LARGE_IO_USED_RATE,
                     LARGE_IO_USED_XACT,
                     LARGE_IO_USED_COUNT,
                     LARGE_IO_USED_PCT
              FROM   ABCXYZ;

       INSERT INTO KOYCACS
             (
              SERVERID,                          HOSTNAME,
              CACHE_SRCH_RATE,                   CACHE_SRCH_XACT,
              CACHE_SRCH_COUNT,                  CACHE_HIT_RATE,
              CACHE_HIT_XACT,                    CACHE_HIT_COUNT,
              CACHE_HIT_PCT,                     CACHE_MISS_RATE,
              CACHE_MISS_XACT,                   CACHE_MISS_COUNT,
              CACHE_MISS_PCT,                    LRU_BUFFERS_RATE,
              LRU_BUFFERS_XACT,                  LRU_BUFFERS_COUNT,
              LRU_BUFFERS_PCT,                   MRU_BUFFERS_RATE,
              MRU_BUFFERS_XACT,                  MRU_BUFFERS_COUNT,
              MRU_BUFFERS_PCT,                   LARGE_IO_PERFORMED_RATE,
              LARGE_IO_PERFORMED_XACT,           LARGE_IO_PERFORMED_COUNT,
              LARGE_IO_PERFORMED_PCT,            LARGE_IO_DENIED_RATE,
              LARGE_IO_DENIED_XACT,              LARGE_IO_DENIED_COUNT,
              LARGE_IO_DENIED_PCT,               LARGE_IO_CACHED_RATE,
              LARGE_IO_CACHED_XACT,              LARGE_IO_CACHED_COUNT,
              LARGE_IO_USED_RATE,                LARGE_IO_USED_XACT,
              LARGE_IO_USED_COUNT,               LARGE_IO_USED_PCT,
              SAMPTIME,                          CACHE_SRCH_RATE,
              CACHE_SRCH_XACT,                   CACHE_SRCH_COUNT,
              CACHE_HIT_RATE,                    CACHE_HIT_XACT,
              CACHE_HIT_COUNT,                   CACHE_HIT_PCT,
              CACHE_MISS_RATE,                   CACHE_MISS_XACT,
              CACHE_MISS_COUNT,                  CACHE_MISS_PCT,
              LRU_BUFFERS_RATE,                  LRU_BUFFERS_XACT,
              LRU_BUFFERS_COUNT,                 LRU_BUFFERS_PCT,
              MRU_BUFFERS_RATE,                  MRU_BUFFERS_XACT,
              MRU_BUFFERS_COUNT,                 MRU_BUFFERS_PCT,
              LARGE_IO_PERFORMED_RATE,           LARGE_IO_PERFORMED_XACT,
              LARGE_IO_PERFORMED_COUNT,          LARGE_IO_PERFORMED_PCT,
              LARGE_IO_DENIED_RATE,              LARGE_IO_DENIED_XACT,
              LARGE_IO_DENIED_COUNT,             LARGE_IO_DENIED_PCT,
              LARGE_IO_CACHED_RATE,              LARGE_IO_CACHED_XACT,
              LARGE_IO_CACHED_COUNT,             LARGE_IO_USED_RATE,
              LARGE_IO_USED_XACT,                LARGE_IO_USED_COUNT,
              LARGE_IO_USED_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :INT!INT01,                        :INT!INT02,
             :INT!INT03,                        :INT!INT04,
             :INT!INT05,                        :INT!INT06,
             :INT!INT07,                        :INT!INT08,
             :INT!INT09,                        :INT!INT10,
             :INT!INT11,                        :INT!INT12,
             :INT!INT13,                        :INT!INT14,
             :INT!INT15,                        :INT!INT16,
             :INT!INT17,                        :INT!INT18,
             :INT!INT19,                        :INT!INT20,
             :INT!INT21,                        :INT!INT22,
             :INT!INT23,                        :INT!INT24,
             :INT!INT25,                        :INT!INT26,
             :INT!INT27,                        :INT!INT28,
             :INT!INT29,                        :INT!INT30,
             :INT!INT31,                        :INT!INT32,
             :INT!INT33,                        :INT!INT34,
             :TS!%now_time,                     :NS!CACHE_SRCH_RATE,
             :NS!CACHE_SRCH_XACT,               :NS!CACHE_SRCH_COUNT,
             :NS!CACHE_HIT_RATE,                :NS!CACHE_HIT_XACT,
             :NS!CACHE_HIT_COUNT,               :NS!CACHE_HIT_PCT,
             :NS!CACHE_MISS_RATE,               :NS!CACHE_MISS_XACT,
             :NS!CACHE_MISS_COUNT,              :NS!CACHE_MISS_PCT,
             :NS!LRU_BUFFERS_RATE,              :NS!LRU_BUFFERS_XACT,
             :NS!LRU_BUFFERS_COUNT,             :NS!LRU_BUFFERS_PCT,
             :NS!MRU_BUFFERS_RATE,              :NS!MRU_BUFFERS_XACT,
             :NS!MRU_BUFFERS_COUNT,             :NS!MRU_BUFFERS_PCT,
             :NS!LARGE_IO_PERFORMED_RATE,       :NS!LARGE_IO_PERFORMED_XACT,
             :NS!LARGE_IO_PERFORMED_COUNT,      :NS!LARGE_IO_PERFORMED_PCT,
             :NS!LARGE_IO_DENIED_RATE,          :NS!LARGE_IO_DENIED_XACT,
             :NS!LARGE_IO_DENIED_COUNT,         :NS!LARGE_IO_DENIED_PCT,
             :NS!LARGE_IO_CACHED_RATE,          :NS!LARGE_IO_CACHED_XACT,
             :NS!LARGE_IO_CACHED_COUNT,         :NS!LARGE_IO_USED_RATE,
             :NS!LARGE_IO_USED_XACT,            :NS!LARGE_IO_USED_COUNT,
             :NS!LARGE_IO_USED_PCT);

;;**********************************************************************
;;
;;     KOYCACD - cache detail
;;
;;**********************************************************************

cursor KOYCACD;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script i1
           KOYCACD;
       math decimal 0 INT01      CACHE_SRCH_RATE * 100;
       math decimal 0 INT02      CACHE_SRCH_XACT * 100;
       math decimal 0 INT03      CACHE_SRCH_COUNT;
       math decimal 0 INT04      CACHE_HIT_RATE * 100;
       math decimal 0 INT05      CACHE_HIT_XACT * 100;
       math decimal 0 INT06      CACHE_HIT_COUNT;
       math decimal 0 INT07      CACHE_HIT_PCT * 100;
       math decimal 0 INT08      CACHE_MISS_RATE * 100;
       math decimal 0 INT09      CACHE_MISS_XACT * 100;
       math decimal 0 INT10      CACHE_MISS_COUNT;
       math decimal 0 INT11      CACHE_MISS_PCT * 100;
       math decimal 0 INT12      LRU_BUFFERS_RATE * 100;
       math decimal 0 INT13      LRU_BUFFERS_XACT * 100;
       math decimal 0 INT14      LRU_BUFFERS_COUNT;
       math decimal 0 INT15      LRU_BUFFERS_PCT * 100;
       math decimal 0 INT16      MRU_BUFFERS_RATE * 100;
       math decimal 0 INT17      MRU_BUFFERS_XACT * 100;
       math decimal 0 INT18      MRU_BUFFERS_COUNT;
       math decimal 0 INT19      MRU_BUFFERS_PCT * 100;
       math decimal 0 INT20      LARGE_IO_PERFORMED_RATE * 100;
       math decimal 0 INT21      LARGE_IO_PERFORMED_XACT * 100;
       math decimal 0 INT22      LARGE_IO_PERFORMED_COUNT;
       math decimal 0 INT23      LARGE_IO_PERFORMED_PCT * 100;
       math decimal 0 INT24      LARGE_IO_DENIED_RATE * 100;
       math decimal 0 INT25      LARGE_IO_DENIED_XACT * 100;
       math decimal 0 INT26      LARGE_IO_DENIED_COUNT;
       math decimal 0 INT27      LARGE_IO_DENIED_PCT * 100;
       math decimal 0 INT28      LARGE_IO_CACHED_RATE * 100;
       math decimal 0 INT29      LARGE_IO_CACHED_XACT * 100;
       math decimal 0 INT30      LARGE_IO_CACHED_COUNT;
       math decimal 0 INT31      LARGE_IO_USED_RATE * 100;
       math decimal 0 INT32      LARGE_IO_USED_XACT * 100;
       math decimal 0 INT33      LARGE_IO_USED_COUNT;
       math decimal 0 INT34      LARGE_IO_USED_PCT * 100;

       insert_select
              SELECT CACHE_NAME,
                     CACHE_SRCH_RATE,
                     CACHE_SRCH_XACT,
                     CACHE_SRCH_COUNT,
                     CACHE_HIT_RATE,
                     CACHE_HIT_XACT,
                     CACHE_HIT_COUNT,
                     CACHE_HIT_PCT,
                     CACHE_MISS_RATE,
                     CACHE_MISS_XACT,
                     CACHE_MISS_COUNT,
                     CACHE_MISS_PCT,
                     LRU_BUFFERS_RATE,
                     LRU_BUFFERS_XACT,
                     LRU_BUFFERS_COUNT,
                     LRU_BUFFERS_PCT,
                     MRU_BUFFERS_RATE,
                     MRU_BUFFERS_XACT,
                     MRU_BUFFERS_COUNT,
                     MRU_BUFFERS_PCT,
                     LARGE_IO_PERFORMED_RATE,
                     LARGE_IO_PERFORMED_XACT,
                     LARGE_IO_PERFORMED_COUNT,
                     LARGE_IO_PERFORMED_PCT,
                     LARGE_IO_DENIED_RATE,
                     LARGE_IO_DENIED_XACT,
                     LARGE_IO_DENIED_COUNT,
                     LARGE_IO_DENIED_PCT,
                     LARGE_IO_CACHED_RATE,
                     LARGE_IO_CACHED_XACT,
                     LARGE_IO_CACHED_COUNT,
                     LARGE_IO_USED_RATE,
                     LARGE_IO_USED_XACT,
                     LARGE_IO_USED_COUNT,
                     LARGE_IO_USED_PCT
              FROM   ABCXYZ;

       INSERT INTO KOYCACD
             (SERVERID,                          HOSTNAME,
              CACHE_NAME,
              CACHE_SRCH_RATE,                   CACHE_SRCH_XACT,
              CACHE_SRCH_COUNT,                  CACHE_HIT_RATE,
              CACHE_HIT_XACT,                    CACHE_HIT_COUNT,
              CACHE_HIT_PCT,                     CACHE_MISS_RATE,
              CACHE_MISS_XACT,                   CACHE_MISS_COUNT,
              CACHE_MISS_PCT,                    LRU_BUFFERS_RATE,
              LRU_BUFFERS_XACT,                  LRU_BUFFERS_COUNT,
              LRU_BUFFERS_PCT,                   MRU_BUFFERS_RATE,
              MRU_BUFFERS_XACT,                  MRU_BUFFERS_COUNT,
              MRU_BUFFERS_PCT,                   LARGE_IO_PERFORMED_RATE,
              LARGE_IO_PERFORMED_XACT,           LARGE_IO_PERFORMED_COUNT,
              LARGE_IO_PERFORMED_PCT,            LARGE_IO_DENIED_RATE,
              LARGE_IO_DENIED_XACT,              LARGE_IO_DENIED_COUNT,
              LARGE_IO_DENIED_PCT,               LARGE_IO_CACHED_RATE,
              LARGE_IO_CACHED_XACT,              LARGE_IO_CACHED_COUNT,
              LARGE_IO_USED_RATE,                LARGE_IO_USED_XACT,
              LARGE_IO_USED_COUNT,               LARGE_IO_USED_PCT,
              SAMPTIME,                          UCACHENM,
              CACHE_SRCH_RATE,
              CACHE_SRCH_XACT,                   CACHE_SRCH_COUNT,
              CACHE_HIT_RATE,                    CACHE_HIT_XACT,
              CACHE_HIT_COUNT,                   CACHE_HIT_PCT,
              CACHE_MISS_RATE,                   CACHE_MISS_XACT,
              CACHE_MISS_COUNT,                  CACHE_MISS_PCT,
              LRU_BUFFERS_RATE,                  LRU_BUFFERS_XACT,
              LRU_BUFFERS_COUNT,                 LRU_BUFFERS_PCT,
              MRU_BUFFERS_RATE,                  MRU_BUFFERS_XACT,
              MRU_BUFFERS_COUNT,                 MRU_BUFFERS_PCT,
              LARGE_IO_PERFORMED_RATE,           LARGE_IO_PERFORMED_XACT,
              LARGE_IO_PERFORMED_COUNT,          LARGE_IO_PERFORMED_PCT,
              LARGE_IO_DENIED_RATE,              LARGE_IO_DENIED_XACT,
              LARGE_IO_DENIED_COUNT,             LARGE_IO_DENIED_PCT,
              LARGE_IO_CACHED_RATE,              LARGE_IO_CACHED_XACT,
              LARGE_IO_CACHED_COUNT,             LARGE_IO_USED_RATE,
              LARGE_IO_USED_XACT,                LARGE_IO_USED_COUNT,
              LARGE_IO_USED_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :CACHE_NAME,
             :INT!INT01,                        :INT!INT02,
             :INT!INT03,                        :INT!INT04,
             :INT!INT05,                        :INT!INT06,
             :INT!INT07,                        :INT!INT08,
             :INT!INT09,                        :INT!INT10,
             :INT!INT11,                        :INT!INT12,
             :INT!INT13,                        :INT!INT14,
             :INT!INT15,                        :INT!INT16,
             :INT!INT17,                        :INT!INT18,
             :INT!INT19,                        :INT!INT20,
             :INT!INT21,                        :INT!INT22,
             :INT!INT23,                        :INT!INT24,
             :INT!INT25,                        :INT!INT26,
             :INT!INT27,                        :INT!INT28,
             :INT!INT29,                        :INT!INT30,
             :INT!INT31,                        :INT!INT32,
             :INT!INT33,                        :INT!INT34,
             :TS!%now_time,                     :CACHE_NAME^90,
             :NS!CACHE_SRCH_RATE,
             :NS!CACHE_SRCH_XACT,               :NS!CACHE_SRCH_COUNT,
             :NS!CACHE_HIT_RATE,                :NS!CACHE_HIT_XACT,
             :NS!CACHE_HIT_COUNT,               :NS!CACHE_HIT_PCT,
             :NS!CACHE_MISS_RATE,               :NS!CACHE_MISS_XACT,
             :NS!CACHE_MISS_COUNT,              :NS!CACHE_MISS_PCT,
             :NS!LRU_BUFFERS_RATE,              :NS!LRU_BUFFERS_XACT,
             :NS!LRU_BUFFERS_COUNT,             :NS!LRU_BUFFERS_PCT,
             :NS!MRU_BUFFERS_RATE,              :NS!MRU_BUFFERS_XACT,
             :NS!MRU_BUFFERS_COUNT,             :NS!MRU_BUFFERS_PCT,
             :NS!LARGE_IO_PERFORMED_RATE,       :NS!LARGE_IO_PERFORMED_XACT,
             :NS!LARGE_IO_PERFORMED_COUNT,      :NS!LARGE_IO_PERFORMED_PCT,
             :NS!LARGE_IO_DENIED_RATE,          :NS!LARGE_IO_DENIED_XACT,
             :NS!LARGE_IO_DENIED_COUNT,         :NS!LARGE_IO_DENIED_PCT,
             :NS!LARGE_IO_CACHED_RATE,          :NS!LARGE_IO_CACHED_XACT,
             :NS!LARGE_IO_CACHED_COUNT,         :NS!LARGE_IO_USED_RATE,
             :NS!LARGE_IO_USED_XACT,            :NS!LARGE_IO_USED_COUNT,
             :NS!LARGE_IO_USED_PCT);

;;**********************************************************************
;;
;;     KOYLOGS - log summary
;;
;;**********************************************************************

cursor KOYLOGS;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script  i1
        KOYLOGS;

       math decimal 0 INT01      MAX_PLC_SIZE;
       math decimal 0 INT02      TRANSACTION_LOG_WRITES;
       math decimal 0 INT03      TRANSACTION_LOG_ALLOC;
       math decimal 0 INT04      PLC_LOG_RECORDS;
       math decimal 0 INT05      TOTAL_PLC_FLUSHES;
       math decimal 0 INT06      TOTAL_PLC_SEMAPHORE_REQ;
       math decimal 0 INT07      TOTAL_LOG_SEMAPHORE_REQ;

       insert_select
              SELECT MAX_PLC_SIZE,
                     TRANSACTION_LOG_WRITES,
                     TRANSACTION_LOG_ALLOC,
                     PLC_LOG_RECORDS,
                     TOTAL_PLC_FLUSHES,
                     TOTAL_PLC_SEMAPHORE_REQ,
                     TOTAL_LOG_SEMAPHORE_REQ
              FROM   ABCXYZ;

       INSERT INTO KOYLOGS
             (SERVERID,                          HOSTNAME,
              MAX_PLC_SIZE,                      TRANSACTION_LOG_WRITES,
              TRANSACTION_LOG_ALLOC,             PLC_LOG_RECORDS,
              TOTAL_PLC_FLUSHES,                 TOTAL_PLC_SEMAPHORE_REQ,
              TOTAL_LOG_SEMAPHORE_REQ,           SAMPTIME,
              MAX_PLC_SIZE,                      TRANSACTION_LOG_WRITES,
              TRANSACTION_LOG_ALLOC,             PLC_LOG_RECORDS,
              TOTAL_PLC_FLUSHES,                 TOTAL_PLC_SEMAPHORE_REQ,
              TOTAL_LOG_SEMAPHORE_REQ)
       VALUES
            (:%me^30,                           :%machine,
             :INT!INT01,                        :INT!INT02,
             :INT!INT03,                        :INT!INT04,
             :INT!INT05,                        :INT!INT06,
             :INT!INT07,                        :TS!%now_time,
             :NS!MAX_PLC_SIZE,                  :NS!TRANSACTION_LOG_WRITES,
             :NS!TRANSACTION_LOG_ALLOC,         :NS!PLC_LOG_RECORDS,
             :NS!TOTAL_PLC_FLUSHES,             :NS!TOTAL_PLC_SEMAPHORE_REQ,
             :NS!TOTAL_LOG_SEMAPHORE_REQ);

;;**********************************************************************
;;
;;     KOYLOGD - log detail
;;
;;**********************************************************************

cursor KOYLOGD;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script i1
       KOYLOGD;

       math decimal 0 INT01      LOG_RATE * 100;
       math decimal 0 INT02      LOG_XACT * 100;
       math decimal 0 INT03      LOG_COUNT;
       math decimal 0 INT04      LOG_PCT * 100;

       insert_select
              SELECT LOG_ACTIVITY,
                     LOG_RATE,
                     LOG_XACT,
                     LOG_COUNT,
                     LOG_PCT
              FROM   ABCXYZ;

       INSERT INTO KOYLOGD
             (
              SERVERID,                          HOSTNAME,
              LOG_ACTIVITY,                      LOG_RATE,
              LOG_XACT,                          LOG_COUNT,
              LOG_PCT,                           SAMPTIME,
              LOG_ACTIVITY,                      LOG_RATE,
              LOG_XACT,                          LOG_COUNT,
              LOG_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :LOG_ACTIVITY,                     :INT!INT01,
             :INT!INT02,                        :INT!INT03,
             :INT!INT04,                        :TS!%now_time,
             :NS!LOG_ACTIVITY,                  :NS!LOG_RATE,
             :NS!LOG_XACT,                      :NS!LOG_COUNT,
             :NS!LOG_PCT);

;;**********************************************************************
;;
;;     KOYSDEVD - device detail per server
;;
;;**********************************************************************

cursor KOYSDEVD;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script i1
       KOYSDEVD;

       math decimal 0 INT01      DEVICE_READ_RATE * 100;
       math decimal 0 INT02      DEVICE_READ_XACT * 100;
       math decimal 0 INT03      DEVICE_READ_COUNT;
       math decimal 0 INT04      DEVICE_READ_PCT * 100;
       math decimal 0 INT05      DEVICE_WRITE_RATE * 100;
       math decimal 0 INT06      DEVICE_WRITE_XACT * 100;
       math decimal 0 INT07      DEVICE_WRITE_COUNT;
       math decimal 0 INT08      DEVICE_WRITE_PCT * 100;
       math decimal 0 INT09      DEVICE_TOTAL_RATE * 100;
       math decimal 0 INT10      DEVICE_TOTAL_XACT * 100;
       math decimal 0 INT11      DEVICE_TOTAL_COUNT;
;;       math decimal 0 INT12      DEVICE_TOTAL_PCT * 100;
;;       math decimal 0 INT12      (DEVICE_TOTAL_PCT/DEVICE_TOTAL_COUNT) * 100;
       math decimal 0 INT12      DEVICE_TOTAL_PCT * 100;
       math decimal 0 INT13      DEVICE_LOCK_GRANTED_RATE * 100;
       math decimal 0 INT14      DEVICE_LOCK_GRANTED_XACT * 100;
       math decimal 0 INT15      DEVICE_LOCK_GRANTED_COUNT;
       math decimal 0 INT16      DEVICE_LOCK_GRANTED_PCT * 100;
       math decimal 0 INT17      DEVICE_LOCK_WAITED_RATE * 100;
       math decimal 0 INT18      DEVICE_LOCK_WAITED_XACT * 100;
       math decimal 0 INT19      DEVICE_LOCK_WAITED_COUNT;
       math decimal 0 INT20      DEVICE_LOCK_WAITED_PCT * 100;

       insert_select
              SELECT DEVICE_NAME,
                     PHYSICAL_NAME,
                     DEVICE_READ_RATE,
                     DEVICE_READ_XACT,
                     DEVICE_READ_COUNT,
                     DEVICE_READ_PCT,
                     DEVICE_WRITE_RATE,
                     DEVICE_WRITE_XACT,
                     DEVICE_WRITE_COUNT,
                     DEVICE_WRITE_PCT,
                     DEVICE_TOTAL_RATE,
                     DEVICE_TOTAL_XACT,
                     DEVICE_TOTAL_COUNT,
                     DEVICE_TOTAL_PCT,
                     DEVICE_LOCK_GRANTED_RATE,
                     DEVICE_LOCK_GRANTED_XACT,
                     DEVICE_LOCK_GRANTED_COUNT,
                     DEVICE_LOCK_GRANTED_PCT,
                     DEVICE_LOCK_WAITED_RATE,
                     DEVICE_LOCK_WAITED_XACT,
                     DEVICE_LOCK_WAITED_COUNT,
                     DEVICE_LOCK_WAITED_PCT
              FROM   ABCXYZ;

       INSERT INTO KOYSDEVD
             (SERVERID,                          HOSTNAME,
              DEVICE_NAME,                       PHYSICAL_NAME,
              DEVICE_READ_RATE,                  DEVICE_READ_XACT,
              DEVICE_READ_COUNT,                 DEVICE_READ_PCT,
              DEVICE_WRITE_RATE,                 DEVICE_WRITE_XACT,
              DEVICE_WRITE_COUNT,                DEVICE_WRITE_PCT,
              DEVICE_TOTAL_RATE,                 DEVICE_TOTAL_XACT,
              DEVICE_TOTAL_COUNT,                DEVICE_TOTAL_PCT,
              DEVICE_LOCK_GRANTED_RATE,          DEVICE_LOCK_GRANTED_XACT,
              DEVICE_LOCK_GRANTED_COUNT,         DEVICE_LOCK_GRANTED_PCT,
              DEVICE_LOCK_WAITED_RATE,           DEVICE_LOCK_WAITED_XACT,
              DEVICE_LOCK_WAITED_COUNT,          DEVICE_LOCK_WAITED_PCT,
              SAMPTIME,                          UDVNAME,
              UPHYNAME,                          DEVICE_NAME,
              PHYSICAL_NAME,                     DEVICE_READ_RATE,
              DEVICE_READ_XACT,                  DEVICE_READ_COUNT,
              DEVICE_READ_PCT,                   DEVICE_WRITE_RATE,
              DEVICE_WRITE_XACT,                 DEVICE_WRITE_COUNT,
              DEVICE_WRITE_PCT,                  DEVICE_TOTAL_RATE,
              DEVICE_TOTAL_XACT,                 DEVICE_TOTAL_COUNT,
              DEVICE_TOTAL_PCT,                  DEVICE_LOCK_GRANTED_RATE,
              DEVICE_LOCK_GRANTED_XACT,          DEVICE_LOCK_GRANTED_COUNT,
              DEVICE_LOCK_GRANTED_PCT,           DEVICE_LOCK_WAITED_RATE,
              DEVICE_LOCK_WAITED_XACT,           DEVICE_LOCK_WAITED_COUNT,
              DEVICE_LOCK_WAITED_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :DEVICE_NAME^30,                   :PHYSICAL_NAME^80,
             :INT!INT01,                        :INT!INT02,
             :INT!INT03,                        :INT!INT04,
             :INT!INT05,                        :INT!INT06,
             :INT!INT07,                        :INT!INT08,
             :INT!INT09,                        :INT!INT10,
             :INT!INT11,                        :INT!INT12,
             :INT!INT13,                        :INT!INT14,
             :INT!INT15,                        :INT!INT16,
             :INT!INT17,                        :INT!INT18,
             :INT!INT19,                        :INT!INT20,
             :TS!%now_time,                     :DEVICE_NAME^90,
             :PHYSICAL_NAME^240,                :NS!DEVICE_NAME,
             :NS!PHYSICAL_NAME,                 :NS!DEVICE_READ_RATE,
             :NS!DEVICE_READ_XACT,              :NS!DEVICE_READ_COUNT,
             :NS!DEVICE_READ_PCT,               :NS!DEVICE_WRITE_RATE,
             :NS!DEVICE_WRITE_XACT,             :NS!DEVICE_WRITE_COUNT,
             :NS!DEVICE_WRITE_PCT,              :NS!DEVICE_TOTAL_RATE,
             :NS!DEVICE_TOTAL_XACT,             :NS!DEVICE_TOTAL_COUNT,
             :NS!DEVICE_TOTAL_PCT,              :NS!DEVICE_LOCK_GRANTED_RATE,
             :NS!DEVICE_LOCK_GRANTED_XACT,      :NS!DEVICE_LOCK_GRANTED_COUNT,
             :NS!DEVICE_LOCK_GRANTED_PCT,       :NS!DEVICE_LOCK_WAITED_RATE,
             :NS!DEVICE_LOCK_WAITED_XACT,       :NS!DEVICE_LOCK_WAITED_COUNT,
             :NS!DEVICE_LOCK_WAITED_PCT);

;;**********************************************************************
;;
;;     KOYTSKD - task detail
;;
;;**********************************************************************

cursor KOYTSKD;

       demand;
       stale 120;
       empty;

       math decimal 0 INT01      TASK_SWITCH_RATE * 100;
       math decimal 0 INT02      TASK_SWITCH_XACT * 100;
       math decimal 0 INT03      TASK_SWITCH_COUNT;
       math decimal 0 INT04      TASK_SWITCH_PCT * 100;

       IF  KOYV.VERSION > 11 ;
        fetch_exit fetchxi1;
        script i1
        KOYTSK2;
        insert_select
             SELECT TASK_CAUSE,
                    TASK_SWITCH_RATE,
                    TASK_SWITCH_XACT,
                    TASK_SWITCH_COUNT,
                    TASK_SWITCH_PCT
             FROM   ABCXYZ;

       ELSE ;
        fetch_exit fetchxi1;
        script i1
        KOYTSKD;
        insert_select
             SELECT TASK_CAUSE,
                    TASK_SWITCH_RATE,
                    TASK_SWITCH_XACT,
                    TASK_SWITCH_COUNT,
                    TASK_SWITCH_PCT
             FROM   ABCXYZ;

       ENDIF;

       INSERT INTO KOYTSKD
             (SERVERID,                          HOSTNAME,
              TASK_CAUSE,                        TASK_SWITCH_RATE,
              TASK_SWITCH_XACT,                  TASK_SWITCH_COUNT,
              TASK_SWITCH_PCT,                   SAMPTIME,
              TASK_CAUSE,                        TASK_SWITCH_RATE,
              TASK_SWITCH_XACT,                  TASK_SWITCH_COUNT,
              TASK_SWITCH_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :TASK_CAUSE,                       :INT!INT01,
             :INT!INT02,                        :INT!INT03,
             :INT!INT04,                        :TS!%now_time,
             :NS!TASK_CAUSE,                    :NS!TASK_SWITCH_RATE,
             :NS!TASK_SWITCH_XACT,              :NS!TASK_SWITCH_COUNT,
             :NS!TASK_SWITCH_PCT);

;;**********************************************************************
;;
;;     KOYSQLD - sql detail
;;
;;**********************************************************************

cursor KOYSQLD;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script i1
       KOYSQLD;

       math decimal 0 INT01      SQL_RATE * 100;
       math decimal 0 INT02      SQL_XACT * 100;
       math decimal 0 INT03      SQL_COUNT;
       math decimal 0 INT04      SQL_PCT * 100;

       pre_cursor SYSCCONF;

       insert_select
              SELECT SQL_ACTIVITY,
                     SQL_RATE,
                     SQL_XACT,
                     SQL_COUNT,
                     SQL_PCT
              FROM   ABCXYZ;

       INSERT INTO KOYSQLD
             (SERVERID,                          HOSTNAME,
              SQL_ACTIVITY,                      SQL_RATE,
              SQL_XACT,                          SQL_COUNT,
              SQL_PCT,                           SAMPTIME,
              SQL_ACTIVITY,                      SQL_RATE,
              SQL_XACT,                          SQL_COUNT,
              SQL_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :SQL_ACTIVITY,                     :INT!INT01,
             :INT!INT02,                        :INT!INT03,
             :INT!INT04,                        :TS!%now_time,
             :NS!SQL_ACTIVITY,                  :NS!SQL_RATE,
             :NS!SQL_XACT,                      :NS!SQL_COUNT,
             :NS!SQL_PCT);

;;**********************************************************************
;;
;;     KOYLCKS - lock summary
;;
;;**********************************************************************

cursor KOYLCKS;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script i1
       KOYLCKS;

       math decimal 0 INT01      LOCK_REQUEST_RATE * 100;
       math decimal 0 INT02      LOCK_REQUEST_XACT * 100;
       math decimal 0 INT03      LOCK_REQUEST_COUNT;
       math decimal 0 INT04      LOCK_CONTENTION_RATE * 100;
       math decimal 0 INT05      LOCK_CONTENTION_XACT * 100;
       math decimal 0 INT06      LOCK_CONTENTION_COUNT;
       math decimal 0 INT07      LOCK_CONTENTION_PCT * 100;
       math decimal 0 INT08      DEADLOCK_RATE * 100;
       math decimal 0 INT09      DEADLOCK_XACT * 100;
       math decimal 0 INT10      DEADLOCK_COUNT;
       math decimal 0 INT11      DEADLOCK_PCT * 100;
       math decimal 0 INT12      LOCK_PROMOTE_RATE * 100;
       math decimal 0 INT13      LOCK_PROMOTE_XACT * 100;
       math decimal 0 INT14      LOCK_PROMOTE_COUNT;
       math decimal 0 INT15      LOCK_PROMOTE_EX_RATE * 100;
       math decimal 0 INT16      LOCK_PROMOTE_EX_XACT * 100;
       math decimal 0 INT17      LOCK_PROMOTE_EX_COUNT;
       math decimal 0 INT18      LOCK_PROMOTE_EX_PCT * 100;
       math decimal 0 INT19      LOCK_PROMOTE_SH_RATE * 100;
       math decimal 0 INT20      LOCK_PROMOTE_SH_XACT * 100;
       math decimal 0 INT21      LOCK_PROMOTE_SH_COUNT;
       math decimal 0 INT22      LOCK_PROMOTE_SH_PCT * 100;

       insert_select
              SELECT LOCK_REQUEST_RATE,
                     LOCK_REQUEST_XACT,
                     LOCK_REQUEST_COUNT,
                     LOCK_CONTENTION_RATE,
                     LOCK_CONTENTION_XACT,
                     LOCK_CONTENTION_COUNT,
                     LOCK_CONTENTION_PCT,
                     DEADLOCK_RATE,
                     DEADLOCK_XACT,
                     DEADLOCK_COUNT,
                     DEADLOCK_PCT,
                     LOCK_PROMOTE_RATE,
                     LOCK_PROMOTE_XACT,
                     LOCK_PROMOTE_COUNT,
                     LOCK_PROMOTE_EX_RATE,
                     LOCK_PROMOTE_EX_XACT,
                     LOCK_PROMOTE_EX_COUNT,
                     LOCK_PROMOTE_EX_PCT,
                     LOCK_PROMOTE_SH_RATE,
                     LOCK_PROMOTE_SH_XACT,
                     LOCK_PROMOTE_SH_COUNT,
                     LOCK_PROMOTE_SH_PCT
              FROM   ABCXYZ;

       INSERT INTO KOYLCKS
             (SERVERID,                          HOSTNAME,
              LOCK_REQUEST_RATE,                 LOCK_REQUEST_XACT,
              LOCK_REQUEST_COUNT,                LOCK_CONTENTION_RATE,
              LOCK_CONTENTION_XACT,              LOCK_CONTENTION_COUNT,
              LOCK_CONTENTION_PCT,               DEADLOCK_RATE,
              DEADLOCK_XACT,                     DEADLOCK_COUNT,
              DEADLOCK_PCT,                      LOCK_PROMOTE_RATE,
              LOCK_PROMOTE_XACT,                 LOCK_PROMOTE_COUNT,
              LOCK_PROMOTE_EX_RATE,              LOCK_PROMOTE_EX_XACT,
              LOCK_PROMOTE_EX_COUNT,             LOCK_PROMOTE_EX_PCT,
              LOCK_PROMOTE_SH_RATE,              LOCK_PROMOTE_SH_XACT,
              LOCK_PROMOTE_SH_COUNT,             LOCK_PROMOTE_SH_PCT,
              SAMPTIME,                          LOCK_REQUEST_RATE,
              LOCK_REQUEST_XACT,                 LOCK_REQUEST_COUNT,
              LOCK_CONTENTION_RATE,              LOCK_CONTENTION_XACT,
              LOCK_CONTENTION_COUNT,             LOCK_CONTENTION_PCT,
              DEADLOCK_RATE,                     DEADLOCK_XACT,
              DEADLOCK_COUNT,                    DEADLOCK_PCT,
              LOCK_PROMOTE_RATE,                 LOCK_PROMOTE_XACT,
              LOCK_PROMOTE_COUNT,                LOCK_PROMOTE_EX_RATE,
              LOCK_PROMOTE_EX_XACT,              LOCK_PROMOTE_EX_COUNT,
              LOCK_PROMOTE_EX_PCT,               LOCK_PROMOTE_SH_RATE,
              LOCK_PROMOTE_SH_XACT,              LOCK_PROMOTE_SH_COUNT,
              LOCK_PROMOTE_SH_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :INT!INT01,                        :INT!INT02,
             :INT!INT03,                        :INT!INT04,
             :INT!INT05,                        :INT!INT06,
             :INT!INT07,                        :INT!INT08,
             :INT!INT09,                        :INT!INT10,
             :INT!INT11,                        :INT!INT12,
             :INT!INT13,                        :INT!INT14,
             :INT!INT15,                        :INT!INT16,
             :INT!INT17,                        :INT!INT18,
             :INT!INT19,                        :INT!INT20,
             :INT!INT21,                        :INT!INT22,
             :TS!%now_time,                     :NS!LOCK_REQUEST_RATE,
             :NS!LOCK_REQUEST_XACT,             :NS!LOCK_REQUEST_COUNT,
             :NS!LOCK_CONTENTION_RATE,          :NS!LOCK_CONTENTION_XACT,
             :NS!LOCK_CONTENTION_COUNT,         :NS!LOCK_CONTENTION_PCT,
             :NS!DEADLOCK_RATE,                 :NS!DEADLOCK_XACT,
             :NS!DEADLOCK_COUNT,                :NS!DEADLOCK_PCT,
             :NS!LOCK_PROMOTE_RATE,             :NS!LOCK_PROMOTE_XACT,
             :NS!LOCK_PROMOTE_COUNT,            :NS!LOCK_PROMOTE_EX_RATE,
             :NS!LOCK_PROMOTE_EX_XACT,          :NS!LOCK_PROMOTE_EX_COUNT,
             :NS!LOCK_PROMOTE_EX_PCT,           :NS!LOCK_PROMOTE_SH_RATE,
             :NS!LOCK_PROMOTE_SH_XACT,          :NS!LOCK_PROMOTE_SH_COUNT,
             :NS!LOCK_PROMOTE_SH_PCT);

;;**********************************************************************
;;
;;     KOYLCKD - lock detail
;;
;;**********************************************************************

cursor KOYLCKD;

       demand;
       stale 120;
       empty;
       fetch_exit fetchxi1;
       script i1
       KOYLCKD;

       math decimal 0 INT01      LOCK_TOTAL_RATE * 100;
       math decimal 0 INT02      LOCK_TOTAL_XACT * 100;
       math decimal 0 INT03      LOCK_TOTAL_COUNT;
       math decimal 0 INT04      LOCK_TOTAL_PCT * 100;
       math decimal 0 INT05      LOCK_GRANTED_RATE * 100;
       math decimal 0 INT06      LOCK_GRANTED_XACT * 100;
       math decimal 0 INT07      LOCK_GRANTED_COUNT;
       math decimal 0 INT08      LOCK_GRANTED_PCT * 100;
       math decimal 0 INT09      LOCK_WAITED_RATE * 100;
       math decimal 0 INT10      LOCK_WAITED_XACT * 100;
       math decimal 0 INT11      LOCK_WAITED_COUNT;
       math decimal 0 INT12      LOCK_WAITED_PCT * 100;
       math decimal 0 INT13      LOCK_DEADLOCKED_RATE * 100;
       math decimal 0 INT14      LOCK_DEADLOCKED_XACT * 100;
       math decimal 0 INT15      LOCK_DEADLOCKED_COUNT;
       math decimal 0 INT16      LOCK_DEADLOCKED_PCT * 100;

       insert_select
              SELECT LOCK_TYPE,
                     LOCK_TOTAL_RATE,
                     LOCK_TOTAL_XACT,
                     LOCK_TOTAL_COUNT,
                     LOCK_TOTAL_PCT,
                     LOCK_GRANTED_RATE,
                     LOCK_GRANTED_XACT,
                     LOCK_GRANTED_COUNT,
                     LOCK_GRANTED_PCT,
                     LOCK_WAITED_RATE,
                     LOCK_WAITED_XACT,
                     LOCK_WAITED_COUNT,
                     LOCK_WAITED_PCT,
                     LOCK_DEADLOCKED_RATE,
                     LOCK_DEADLOCKED_XACT,
                     LOCK_DEADLOCKED_COUNT,
                     LOCK_DEADLOCKED_PCT
              FROM   ABCXYZ;

       INSERT INTO KOYLCKD
             (SERVERID,                          HOSTNAME,
              LOCK_TYPE,                         LOCK_TOTAL_RATE,
              LOCK_TOTAL_XACT,                   LOCK_TOTAL_COUNT,
              LOCK_TOTAL_PCT,                    LOCK_GRANTED_RATE,
              LOCK_GRANTED_XACT,                 LOCK_GRANTED_COUNT,
              LOCK_GRANTED_PCT,                  LOCK_WAITED_RATE,
              LOCK_WAITED_XACT,                  LOCK_WAITED_COUNT,
              LOCK_WAITED_PCT,                   LOCK_DEADLOCKED_RATE,
              LOCK_DEADLOCKED_XACT,              LOCK_DEADLOCKED_COUNT,
              LOCK_DEADLOCKED_PCT,               SAMPTIME,
              LOCK_TYPE,                         LOCK_TOTAL_RATE,
              LOCK_TOTAL_XACT,                   LOCK_TOTAL_COUNT,
              LOCK_TOTAL_PCT,                    LOCK_GRANTED_RATE,
              LOCK_GRANTED_XACT,                 LOCK_GRANTED_COUNT,
              LOCK_GRANTED_PCT,                  LOCK_WAITED_RATE,
              LOCK_WAITED_XACT,                  LOCK_WAITED_COUNT,
              LOCK_WAITED_PCT,                   LOCK_DEADLOCKED_RATE,
              LOCK_DEADLOCKED_XACT,              LOCK_DEADLOCKED_COUNT,
              LOCK_DEADLOCKED_PCT)
       VALUES
            (:%me^30,                           :%machine,
             :LOCK_TYPE,                        :INT!INT01,
             :INT!INT02,                        :INT!INT03,
             :INT!INT04,                        :INT!INT05,
             :INT!INT06,                        :INT!INT07,
             :INT!INT08,                        :INT!INT09,
             :INT!INT10,                        :INT!INT11,
             :INT!INT12,                        :INT!INT13,
             :INT!INT14,                        :INT!INT15,
             :INT!INT16,                        :TS!%now_time,
             :NS!LOCK_TYPE,                     :NS!LOCK_TOTAL_RATE,
             :NS!LOCK_TOTAL_XACT,               :NS!LOCK_TOTAL_COUNT,
             :NS!LOCK_TOTAL_PCT,                :NS!LOCK_GRANTED_RATE,
             :NS!LOCK_GRANTED_XACT,             :NS!LOCK_GRANTED_COUNT,
             :NS!LOCK_GRANTED_PCT,              :NS!LOCK_WAITED_RATE,
             :NS!LOCK_WAITED_XACT,              :NS!LOCK_WAITED_COUNT,
             :NS!LOCK_WAITED_PCT,               :NS!LOCK_DEADLOCKED_RATE,
             :NS!LOCK_DEADLOCKED_XACT,          :NS!LOCK_DEADLOCKED_COUNT,
             :NS!LOCK_DEADLOCKED_PCT);



cursor KOYVSTAT;

       interval 99;
           limit 400 ;
       once;

       IF KOYV.VERSION > 11 ;
       
          math decimal 0 PROCCPCT  (PROCCSIZE/MAXMEMSIZE)*100;
      
          insert_select
              SELECT MAXLOCKS   = t1.value,
                     PROCCSIZE  = t2.value,
                     LOGONMAX   = t3.value,
                     MAXMEMSIZE = t4.value,
                     TIMETICKS  = @@timeticks
              FROM   master..syscurconfigs t1,
                     master..syscurconfigs t2,
                     master..syscurconfigs t3,
                     master..syscurconfigs t4
              WHERE  t1.config  = 106
              AND    t2.config  = 146
              AND    t3.config  = 103
              AND    t4.config  = 396;
  
       LOAD MAXLOCKS              -> KOYV.MAXLOCKS;
       LOAD PROCCPCT              -> KOYV.PROCCPCT;
       LOAD LOGONMAX              -> KOYV.LOGONMAX;
       LOAD TIMETICKS             -> KOYV.TIMETICKS;

       INSERT INTO KOYVSTAT
             (MAXLOCKS,              PROCCPCT,              LOGONMAX,
              TIMETICKS,             PROCCSIZE,             MAXMEMSIZE)
       VALUES
            (:MAXLOCKS,             :PROCCPCT,             :LOGONMAX,
             :TIMETICKS,            :NS!PROCCSIZE,         :NS!MAXMEMSIZE);

       ELSE ;
       
          insert_select
              SELECT MAXLOCKS   = t1.value,
                     PROCCPCT   = t2.value,
                     LOGONMAX   = t3.value,
                     TIMETICKS  = @@timeticks
              FROM   master..syscurconfigs t1,
                     master..syscurconfigs t2,
                     master..syscurconfigs t3
              WHERE  t1.config  = 106
              AND    t2.config  = 108
              AND    t3.config  = 103;

       LOAD MAXLOCKS              -> KOYV.MAXLOCKS;
       LOAD PROCCPCT              -> KOYV.PROCCPCT;
       LOAD LOGONMAX              -> KOYV.LOGONMAX;
       LOAD TIMETICKS             -> KOYV.TIMETICKS;

       INSERT INTO KOYVSTAT
             (MAXLOCKS,              PROCCPCT,              LOGONMAX,
              TIMETICKS)
       VALUES
            (:MAXLOCKS,             :PROCCPCT,             :LOGONMAX,
             :TIMETICKS);

      ENDIF;



cursor DBD1;

       stale 10;
       limit 200;
       demand;
       empty;


       decode ERRSTATUS & 32,   'Yes';
       decode ERRSTATUS & 64,   'Yes';
       decode ERRSTATUS & 256,  'Yes';
       decode ERRSTATUS default 'No ';
       decode DBOONLY   & 2048, 'Yes';
       decode DBOONLY  default  'No ';
       decode SINGUSER  & 4096, 'Yes';
       decode SINGUSER default  'No ';
       decode READONLY  & 1024, 'Yes';
       decode READONLY default  'No ';
       decode SELINTOB  &    4, 'Yes';
       decode SELINTOB default  'No ';
       decode NOFREESPA &    2, 'Yes';
       decode NOFREESPA default 'No ';
       decode ABTRNFULL &    1, 'Yes';
       decode ABTRNFULL default 'No ';
       decode TRUNLOGC  &    8, 'Yes';
       decode TRUNLOGC  default 'No ';
       decode NOCKPTREC &   16, 'Yes';
       decode NOCKPTREC default 'No ';

       column_exit ERRSTATUS l_justify;
       column_exit DBOONLY   l_justify;
       column_exit SINGUSER  l_justify;
       column_exit READONLY  l_justify;
       column_exit SELINTOB  l_justify;
       column_exit NOFREESPA l_justify;
       column_exit ABTRNFULL l_justify;
       column_exit TRUNLOGC  l_justify;
       column_exit NOCKPTREC l_justify;

       insert_select
              SELECT DBNAME     = db.name,
                     DBID       = db.dbid,
                     OWNER      = suser_name(db.suid),
                     ERRSTATUS  = db.status,
                     DBOONLY    = db.status,
                     SINGUSER   = db.status,
                     READONLY   = db.status,
                     SELINTOB   = db.status,
                     NOFREESPA  = db.status2,
                     TRUNLOGC   = db.status,
                     ABTRNFULL  = db.status2,
                     NOCKPTREC  = db.status,
                     DUMPTRDATE = convert(char(30),db.dumptrdate,2)
              FROM   master..sysdatabases db;

       LOAD COUNT!DBID            -> KOYV.NUMDBS;

       IN_LIST DBD1_DBNAME_L using DBNAME;

       INSERT INTO DBD1
             (DBNAME,                DBID,                  OWNER,
              ERRSTATUS,             DBOONLY,               SINGUSER,
              READONLY,              SELINTOB,              DUMPTRDATE,
              NOFREESPA,             ABTRNFULL,             TRUNLOGC,
              NOCKPTREC,             UDBNAME,               UDBID)
       VALUES
            (:DBNAME,               :DBID,                 :OWNER,
             :ERRSTATUS,            :DBOONLY,              :SINGUSER,
             :READONLY,             :SELINTOB,             :DUMPTRDATE,
             :NOFREESPA,            :ABTRNFULL,            :TRUNLOGC,
             :NOCKPTREC,            :DBNAME^90,            :DBID^36);


cursor DBD2;

       stale 10;
       limit 200;
       demand;
       empty;
       fetch_exit fetchx2;
       script koy##sql
        -logon [KOYV.LOGONID
;;      -password [KOYV.PASSWORD
            -rdbms [KOYV.SERVERID
            1 " " sp_helpdb [DBD1.DBD1_DBNAME_L;

       math decimal 0 LOGSIZE    (LOGSIZEKB / 1024) * 100;
       math decimal 0 DBSIZE     (DBSIZEKB  / 1024) * 100;
       math decimal 0 DBFREE     (DBFREEKB   / 1024) * 100;
       math decimal 0 LOGFREE    (LOGFREEKB  / 1024) * 100;
       math decimal 0 PCTDBFREE  (DBFREEKB /DBSIZEKB) * 10000;
       math decimal 0 PCTLOGFREE (LOGFREEKB /LOGSIZEKB) * 10000;

       insert_select
              SELECT DBNAME,
                     DBID,
                     LOGSIZEKB,
                     DBSIZEKB,
                     LOGFREEKB,
                     DBFREEKB,
                     LOGDATA
              FROM   ABCXYZ;

       BASE DBD1 on DBNAME        -> DBNAME;

       LOAD MIN!PCTDBFREE         -> KOYV.MINDBFREE;
       LOAD MIN!PCTLOGFREE        -> KOYV.MINLOGFREE;

       INSERT INTO DBD2
             (DBNAME,                DBID,                  OWNER,
              ERRSTATUS,             DBOONLY,               SINGUSER,
              READONLY,              SELINTOB,              DUMPTRDATE,
              NOFREESPA,             ABTRNFULL,             TRUNLOGC,
              NOCKPTREC,             DBSIZE,                DBFREE,
              LOGSIZE,               LOGFREE,               PCTDBFREE,
              PCTLOGFREE,            DBSIZEKB,              DBFREEKB,
              LOGSIZEKB,             LOGFREEKB,             LOGDATA,
              UDBNAME                UDBID)
       VALUES
            (:DBNAME,               :DBD1.DBID,            :DBD1.OWNER,
             :DBD1.ERRSTATUS,       :DBD1.DBOONLY,         :DBD1.SINGUSER,
             :DBD1.READONLY,        :DBD1.SELINTOB,        :DBD1.DUMPTRDATE,
             :DBD1.NOFREESPA,       :DBD1.ABTRNFULL,       :DBD1.TRUNLOGC,
             :DBD1.NOCKPTREC,       :DBSIZE,               :DBFREE,
             :LOGSIZE,              :LOGFREE,              :PCTDBFREE,
             :PCTLOGFREE,           :DBSIZEKB,             :DBFREEKB,
             :LOGSIZEKB,            :LOGFREEKB,            :LOGDATA,
             :DBNAME^90,            :DBD1.DBID^36);


cursor DBD3;

      stale 10;
       limit 200;
       demand;
       empty;

       insert_select
        SELECT
                "d3" = (d3.status &  32),
                "d33" = (d3.status & 256),
                "d4" = (d4.status & 1024),
                "d5" = (d5.status & 2048),
                "d6" = (d6.status & 4096),
                "d7" = (d7.status & 2)
        into #dbd3
        FROM    master..sysdatabases d3,
                master..sysdatabases d4,
                master..sysdatabases d5,
                master..sysdatabases d6,
                master..sysdatabases d7
        WHERE   (d4.dbid = d6.dbid and d4.dbid = d5.dbid and
                 d4.dbid = d7.dbid and d4.dbid = d3.dbid) and
                ((d3.status &   32 =   32)
            or     (d3.status &  256 =  256)
            or     (d4.status & 1024 = 1024)
            or     (d5.status & 2048 = 2048)
            or     (d6.status & 4096 = 4096)
            or     (d7.status &    2 =    2))
        SELECT  NUMERRST  = (sum(d3) / 32) + (sum(d33) / 256),
                NUMRO     = (sum(d4) / 1024),
                NUMDBO    = (sum(d5) / 4086),
                NUMSING   = (sum(d6) / 4096),
                NUMNOFRSP = (sum(d7) / 2)
        FROM #dbd3
        DROP table #dbd3;

       LOAD NUMERRST              -> KOYV.NUMERRST;
       LOAD NUMRO                 -> KOYV.NUMRO;
       LOAD NUMDBO                -> KOYV.NUMDBO;
       LOAD NUMSING               -> KOYV.NUMSING;
       LOAD NUMNOFRSP             -> KOYV.NUMNOFRSP;

       INSERT INTO DBD3
             (NUMERRST,                          NUMRO,
              NUMDBO,                            NUMSING,
              NUMNOFRSP)
       VALUES
            (:NUMERRST,                         :NUMRO,
             :NUMDBO,                           :NUMSING,
             :NUMNOFRSP);


cursor KOYDBD;

       stale 10;
       limit 200;
       demand;
       empty;

       pre_cursor DBD1;
       pre_cursor DBD2;
       
       IF KOYV.VERSION < '15';  
         insert_select
              SELECT DBID       = db.dbid,
                     NUMDEVICES = count(distinct dv.name)
              FROM   master..sysdatabases db,
                     master..sysusages    us,
                     master..sysdevices   dv
              WHERE  db.dbid    = us.dbid
              AND    db.dbid    =  [DBD2.DBD1.DBID
              AND    us.vstart  between dv.low and dv.high
              AND    dv.cntrltype = 0
              GROUP BY db.dbid;              
       ELSE;       
         insert_select
              SELECT DBID       = db.dbid,
                     NUMDEVICES = count(distinct dv.name)
              FROM   master..sysdatabases db,
                     master..sysusages    us,
                     master..sysdevices   dv
              WHERE  db.dbid    = us.dbid
              AND    db.dbid    =  [DBD2.DBD1.DBID
              AND    us.vdevno = dv.vdevno
              AND    dv.cntrltype = 0
              GROUP BY db.dbid;
       ENDIF;

       ITERATE DBD2;

       INSERT INTO KOYDBD
             (SERVERID,              HOSTNAME,
              DBNAME,                DBID,                  OWNER,
              ERRSTATUS,             DBOONLY,               SINGUSER,
              READONLY,              SELINTOB,              DUMPTRDATE,
              NOFREESPA,             ABTRNFULL,             TRUNLOGC,
              NOCKPTREC,             DBSIZE,                LOGSIZE,
              DBFREE,                LOGFREE,               PCTDBFREE,
              PCTLOGFREE,            NUMDEVICES,            SAMPTIME,
              UDBNAME,               UOWNER)
       VALUES
            (:%me^30,               :%machine,
             :DBD2.DBNAME^30,       :DBD2.DBD1.DBID^12,    :DBD2.DBD1.OWNER^8,
             :DBD2.DBD1.ERRSTATUS^3,:DBD2.DBD1.DBOONLY^3,  :DBD2.DBD1.SINGUSER^3,
             :DBD2.DBD1.READONLY^3, :DBD2.DBD1.SELINTOB^3, :DBD2.DBD1.DUMPTRDATE^8,
             :DBD2.DBD1.NOFREESPA^3,:DBD2.DBD1.ABTRNFULL^3,:DBD2.DBD1.TRUNLOGC^3,
             :DBD2.DBD1.NOCKPTREC^3,:INT!DBD2.DBSIZE,      :INT!DBD2.LOGSIZE,
             :INT!DBD2.DBFREE,      :INT!DBD2.LOGFREE,     :INT!DBD2.PCTDBFREE,
             :INT!DBD2.PCTLOGFREE,  :INT!NUMDEVICES,       :TS!%now_time,
             :DBD2.DBNAME^90,       :DBD2.DBD1.OWNER^64);


cursor KOYDBS;

       interval 180;
       empty;
       limit 400;
       no_sql;

       pre_cursor DBD1;
       pre_cursor DBD2;
       pre_cursor DBD3;

       INSERT INTO KOYDBS
             (SERVERID,              HOSTNAME,
              NUMDBS,                MINDBFREE,             MINLOGFREE,
              NUMERRST,              NUMRO,                 NUMDBO,
              NUMSING,               NUMNOFRSP,             CURRINTL,
              SAMPTIME,              PMDESC,                PMVALUE)
       VALUES
            (:%me^30,               :%machine,
             :INT!KOYV.NUMDBS,      :INT!KOYV.MINDBFREE,   :INT!KOYV.MINLOGFREE,
             :INT!KOYV.NUMERRST,    :INT!KOYV.NUMRO,       :INT!KOYV.NUMDBO,
             :INT!KOYV.NUMSING,     :INT!KOYV.NUMNOFRSP,   :INT!%current_interval,
             :TS!%now_time,         :KOYV.PMDESC^1,        :KOYV.PMVALUE^1);



;;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 cursor KOYLOCKS;
 demand;
 empty;


  insert_select
        SELECT
              PIDHOLD  = lk.spid,
              DBID     = lk.dbid,
              TBID     = convert(char(16),lk.id),
              DBNAME   = db_name(lk.dbid),
              TBNAME   = object_name(lk.id,lk.dbid),
              LOCKTYPE = sv.name,
              CCLASS   = lk.class,
              PAGE     = lk.page
          FROM master..syslocks lk,
               master..spt_values sv
          WHERE    sv.type = 'L'
          AND      sv.number = lk.type
          ORDER BY lk.dbid;


          LOAD  COUNT!LOCKTYPE  -> KOYV.NUMLOCKS;
          LOAD  DBNAME          -> KOYV.MAXLOCK
                            FROM max_occurance  DBNAME;
          LOAD  DBNAME          -> KOYV.UMAXLOCK
                            FROM max_occurance  DBNAME;
          LOAD  TBNAME          -> KOYV.TBMAXLOCK
                            FROM max_occurance  TBNAME;
          LOAD  TBNAME          -> KOYV.UTBMXLOCK
                            FROM max_occurance  TBNAME;

 INSERT INTO KOYLOCKS
       (
           SERVERID,            HOSTNAME,          LOCKTYPE,
           PIDHOLD,             DBNAME,            DBID,
           TBNAME,
           PAGE,                CCLASS,            SAMPTIME,
           UDBNAME,             UTBNAME,           UCCLASS)
 VALUES

           (:%me^32,               :%machine,
            :LOCKTYPE^30,
            :INT!PIDHOLD,        :DBNAME^16,        :INT!DBID,
            :TBNAME^16,
            :INT!PAGE,           :CCLASS^30         :TS!%now_time,
            :DBNAME^36,          :TBNAME^48,        :CCLASS^90);

;;------------------------------------------------------------------------------------------
cursor BLOCOUNT;
demand;
empty;

insert_select
   SELECT TOTBLOCK = count(*)
       FROM master..sysprocesses
       WHERE blocked != 0;

   LOAD TOTBLOCK -> KOYV.NUMBLOCK;

INSERT INTO BLOCOUNT
    (TOTBLOCK)
VALUES
    (:TOTBLOCK);

;;---------------------------------------------------------------------------------------
cursor PROCOUNT;
demand;
empty;

insert_select
    SELECT TOTPROC = count(*)
        FROM master..sysprocesses;

LOAD TOTPROC -> KOYV.NUMPROCESS;
INSERT INTO PROCOUNT
     ( TOTPROC )
VALUES
     (:TOTPROC);

;;----------------------------------------------------------------------------------------
cursor KOYLOCK;
demand;
empty;

pre_cursor  PROCOUNT;
pre_cursor  BLOCOUNT;

math decimal 0  PCTBLOCK (KOYV.NUMBLOCK/KOYV.NUMPROCESS) * 10000;


insert_select
      SELECT
             DBID      = dbid,
             DBNAME    = db_name(dbid),
             SRVUSER   = suid,
             CLNTUSER  = uid,
             SRVGROUP  = gid,
             PROCESSID = spid,
             BLOCKID   = blocked,
             BLOCKTM   = time_blocked
      FROM   master..sysprocesses
      WHERE blocked != 0;

      LOAD COUNT BLOCKID -> KOYV.NUMCONFL 
           WHERE BLOCKID > 0 ;

      LOAD DBNAME       -> KOYV.MAXBLOCK
           FROM  max_occurance  DBNAME;
      LOAD DBNAME       -> KOYV.UMAXBLOCK
           FROM  max_occurance  DBNAME;

      LOAD  PCTBLOCK    -> KOYV.PCTBLOCK;

INSERT INTO KOYLOCK
       (
        SERVERID,            HOSTNAME,            DBNAME,
        DBID,                SRVUSER,
        PROCESSID,           BLOCKID,             BLOCKTM,
        SAMPTIME,            UDBNAME,
        USRVUSER,            PCTBLOCK)
 VALUES

         ( :%me^32,               :%machine,
           :DBNAME^30,
           :INT!DBID,             :SRVUSER^8,
           :INT!PROCESSID,        :INT!BLOCKID,          :INT!BLOCKTM,
           :TS!%now_time,         :DBNAME^90,
           :SRVUSER^24,           :NS!PCTBLOCK);



;;============================================================================
cursor GETADDR;
demand;
empty;


 fetch_exit fetchx2;
 script koy##sql
        -logon [KOYV.LOGONID
;;      -password [KOYV.PASSWORD
        -rdbms [KOYV.SERVERID
        4 [%parm0 ;
;         4 9;
insert_select
  SELECT  SQLADDR,
          PID
  FROM    ABCXYZ;

LOAD SQLADDR  -> KOYV.SQLADDR;

INSERT INTO GETADDR
        (SQLADDR, PID)
VALUES (:SQLADDR,  :PID);




cursor KOYSQL;
demand;
empty;

   pre_cursor GETADDR;

   
   IF KOYV.SYSTYPE1 > 0 ;
   fetch_exit  fetchx2;
     script kddos64 ssm [KOYV.TXTPARM  [KOYV.SQLADDR  -s;


    insert_select
    SELECT  SEQNUM,
            SQLTEXT
            FROM   ABCXYZ;
   ELSE;
   fetch_exit  fetchx2;
     script kddos ssm [KOYV.TXTPARM  [KOYV.SQLADDR  -s;


    insert_select
    SELECT  SEQNUM,
            SQLTEXT
            FROM   ABCXYZ;
   ENDIF;

INSERT INTO KOYSQL
   ( SERVERID,          HOSTNAME,
     DBNAME,
                  PID,               SQLTEXT,
     SEQNUM,              SAMPTIME,  UDBNAME,
     USQLTEXT)
VALUES
    (:%me^32,            :%machine,
     :KOYV.DBNAME^30,
     :INT!GETADDR.PID,   :SQLTEXT^60,
     :INT!SEQNUM,        :TS!%now_time,
     :KOYV.DBNAME^90,
     :SQLTEXT^180);



;;**********************************************************************
;;
;;     KOYPRCD - PROCESS DETAIL
;;
;;     NOTE: THIS CURSOR MUST BE EXECUTE BEFORE KOYSRVR AND KOYSRVS
;;
;;**********************************************************************
;;
;;     PRC1 - GET TOTAL OPERATING SYSTEM CPU

cursor OSCPU;

       demand;
       stale 10;
       limit 1;

       IF KOYV.SYSTYPE1 > 0 ;
          fetch_exit fetchx2;
          script kddos64 cpu;

          insert_select
             SELECT  NCPU, PCTOSCPU
                FROM ABCXYZ;
       ELSE;
          fetch_exit fetchx2;
          script kddos cpu;

          insert_select
             SELECT  NCPU, PCTOSCPU
                FROM ABCXYZ;
       ENDIF;

       LOAD PCTOSCPU  -> KOYV.PCTOSCPU;
       LOAD NCPU      -> KOYV.NCPU;

  INSERT INTO OSCPU (NCPU, PCTOSCPU)
  VALUES            (:NCPU,:PCTOSCPU);

;;  Code note on cpu times:
;;  Internal CPU from master..sysprocesses is (cpu * @@timeticks) / 1E6 sec.
;;    (timeticks is always 100,000, so cpu is really 10th of a second)
;;  External CPU from kddos is cpu * 10000. (.1 msecs)
;;    the idiom (cpu * @@timeticks / 100) makes the two the same unit.
;;  CPU percentages are calculated from the current and one prior cursor, to
;;    make sure that a short interval between cursor runs doesn't skew the numbers
;;    (current + prior cpu in .1 msec) / Ncpu / (current + prior time in sec)
;;    resulting in units of .00001 or .01%, which is how they get reported to the CMS
;;  Each cursor is soley responsible for its own time calculation so no sync
;;    requirements between them.
;;
;;     PRC1 - GET EXTERNAL CPU FOR SYBASE CLIENT PROCESS
;;
;;   cursors PRC1 and PRC2 are run for any of the following reasons:
;;   1. PRC3 runs on its sched. interval.
;;   2. demand for KOYPRCD


cursor PRC1;
       demand;
       empty;
       limit 1;

       IF KOYV.SYSTYPE2 > 0 ;
          fetch_exit fetchx2;
          script kddos64 pss [KOYV.OSPROCID;

          math decimal 0 PCTCPU  (CPU - KOYV.LAGSRVCPU) / KOYV.NCPU /
                               %current_interval;
          decode PCTCPU < 0, 0;

          insert_select
             SELECT DUMMYCHR, DUMMYCHR, CPU FROM ABCXYZ;
       ELSE;
          fetch_exit fetchx2;
          script kddos pss [KOYV.OSPROCID;

          math decimal 0 PCTCPU  (CPU - KOYV.LAGSRVCPU) / KOYV.NCPU /
                               %current_interval;
          decode PCTCPU < 0, 0;

          insert_select
             SELECT DUMMYCHR, DUMMYCHR, CPU FROM ABCXYZ;
       ENDIF;

       LOAD  PCTCPU ->  KOYV.PCTCPU;
       LOAD     CPU ->  KOYV.LAGSRVCPU;

       INSERT INTO PRC1
            (PCTCPU,  CPU, INTERVAL)
         VALUES
            (:PCTCPU, :CPU,:%current_interval);

;;
;;    PRC2 - GET SYBASE INTERNAL TOTAL CPU FOR CLIENT PROCESSES
;;
;;cursor PRC2;
;;       demand;
;;       empty;
;;       limit 200;
;;       age_to PRC2_;
;;       base PRC2_ on PIDC -> PIDC;
;;
;;       conditional_dummy_last_row;
;;
;;       MATH  APPCPUPCT   (INTCPU - PRC2_.INTCPU) / KOYV.NCPU /
;;                         (%current_interval);
;;
;;       insert_select
;;              SELECT PID    = spid,
;;                     PIDC   = hostprocess,
;;                     INTCPU = (cpu * @@timeticks) / 100
;;              FROM   master..sysprocesses
;;                     where cpu > 0;
;;
;;       LOAD SUM!APPCPUPCT -> KOYV.APPCPUPCT;
;;
;;       INSERT INTO PRC2 (PID,  PIDC,   INTCPU,  APPCPUPCT,  GOO)
;;       VALUES          (:PID, :PIDC^8, :INTCPU, :APPCPUPCT,
;;                     :%current_interval);
;;;;
;;;; PRC3:  EXTERNAL CPU FOR SYBASE CLIENTS.
;;;;
;;cursor PRC3;
;;;;    interval 60;
;;      demand;
;;      empty;
;;      pre_cursor OSCPU;
;;      pre_cursor PRC1;
;;      pre_cursor PRC2;
;;      iterate PRC2;
;;;;;   iterate PRC2 where PRC2.PIDC ^= '        ';
;;
;;       age_to PRC3_;
;;       base PRC3_ on PIDC -> PIDC;
;;       dummy_last_row;
;;
;;       fetch_exit fetchx2;
;;;;     script kddos pss [PRC2.PIDC;
;;       script echo [PRC2.PIDC dummy 1234 12345 etc;
;;
;;       MATH DECIMAL 0 CPU (PRC2.INTCPU + EXTCPU);
;;       MATH DECIMAL 0 PCTCPU (CPU - PRC3_.CPU) / KOYV.NCPU /
;;                              %current_interval;
;;
;;       insert_select
;;              SELECT PIDC, DUMMYCHR, EXTCPU, MEMORY
;;              FROM   ABCXYZ;
;;
;;       INSERT INTO PRC3    (PIDC, CPU,  PCTCPU,  EXTCPU,  MEMORY,  ELAPSE)
;;       VALUES             (:PIDC,:CPU, :PCTCPU, :EXTCPU, :MEMORY, :%current_interval);
;;
;;;; age_to cursors to satisfy the parser
;;;ursor PRC1_;
;;;demand;
;;;INSERT INTO PRC1_ (X) VALUES (:X);
;;cursor PRC2_;
;; demand;
;; INSERT INTO PRC2_ (X) VALUES (:X);
cursor KOYPRCD;

       stale 10;
       limit 200;
       demand;
       age_to LAG;
       empty;
       base LAG on PROCESSID -> PROCESSID;

       pre_cursor OSCPU;
       pre_cursor PRC1;
;;     pre_cursor PRC2;
;;     pre_cursor PRC3;
;;     BASE PRC3 on PIDC       -> PIDC;

;;This is percentage
       MATH DECIMAL 0 PCTCPU (CPU - LAG.CPU) / KOYV.NCPU /
                                %current_interval * 100;

       decode PCTCPU  < 0, 0;
;;         probably spid numnber was reused

       LOAD SUM!PCTCPU  -> KOYV.APPCPUPCT;

       decode STATUSD = 'recv sleep','Yes';
       decode STATUSD = 'send sleep','Yes';
       decode STATUSD = 'alarm sleep','Yes';
       decode STATUSD = 'sleeping','Yes';
       decode STATUSD default 'No ';

       insert_select
              SELECT PROCESSID  = pr.spid,
                     PROCESSNM  = convert(char(30),sl.name),
                     DBNAME     = db_name(pr.dbid),
                     STATUS     = pr.status,
                     STATUSD    = pr.status,
                     IO         = pr.physical_io,
                     BLOCKTM    = pr.time_blocked * 10000,
                     BLOCKID    = pr.blocked,
                     OSPID      = pr.kpid,
                     SRVUSER    = sl.name,
                     CMDNAME    = pr.cmd,
                     CLNTHOST   = pr.hostname,
                     PIDC    = pr.hostprocess,
                     CPU     = pr.cpu,
                     MEMORY  = pr.memusage,
;;                     (this number less accurate than kddos memory number)
                     TRANNAME   = pr.tran_name,
                     PGMNAME    = pr.program_name,
                     CLNTUSER   = pr.uid,
                     SRVGROUP   = pr.gid,
                     NETWKPK    = pr.network_pktsz
              FROM   master..sysprocesses pr,
                     master..syslogins    sl
              WHERE  pr.suid   *= sl.suid;

;;     COUNT PROCESSES
       LOAD COUNT!PROCESSID       -> KOYV.NUMPROCESS;

;;     COUNT DISTINCT NUMBER OF BLOCKERS (CAUSING CONFLICTS)
       LOAD COUNT BLOCKID         -> KOYV.NUMBLOCK
                                     WHERE BLOCKID > 0;

;;     IDENTIFY INFECTED PROCESS WHERE STATUS = infected
       LOAD COUNT STATUS          -> KOYV.NUMINFECT
                                     WHERE STATUS  = 'infected';

;;     IDENTIFY INFECTED PROCESS WHERE STATUS = bad status
       LOAD COUNT STATUS          -> KOYV.NUMBAD
                                     WHERE STATUS = 'bad status';

;;     IDENTIFY INFECTED PROCESS WHERE STATUS = stopped
       LOAD COUNT STATUS          -> KOYV.NUMSTOPPED
                                     WHERE STATUS = 'stopped';

;;     IDENTIFY INFECTED PROCESS WHERE STATUS = lock sleep
       LOAD COUNT STATUS          -> KOYV.NUMSLPLCK
                                     WHERE STATUS = 'lock sleep';

;;     IDENTIFY INFECTED PROCESS WHERE STATUS OTHER THAN lock sleep
       LOAD COUNT STATUS          -> KOYV.NUMSLPOTH
                                     WHERE STATUSD = 'Yes';

;;     IDENTIFY INFECTED PROCESS WHERE STATUS OTHER THAN lock sleep
       LOAD COUNT STATUS          -> KOYV.NUMLOGSUS
                                     WHERE STATUS = 'log suspend';

       INSERT INTO KOYPRCD
             (SERVERID,              HOSTNAME,
              PROCESSID,             DBNAME,                STATUS,
              CPU,                   PCTCPU,                IO,
              MEMORY,                BLOCKTM,               BLOCKID,
              OSPID,                 SRVUSER,               CMDNAME,
              CLNTHOST,              PIDC,               TRANNAME,
              PGMNAME,               CLNTUSER,              SRVGROUP,
              NETWKPK,
               PROCESSNM,             SAMPTIME,
              UDBNAME,
              UBLOCKID,             USRVUSER,             UCMDNAME,
              UTRANNAME,            UPGMNAME,             UCLNTUSER,
              USRVGROUP,            UPROCESSNM,
              STATUSD,              INTERVAL)
       VALUES
            (:%me^32,               :%machine,
             :INT!PROCESSID,        :DBNAME^30,            :STATUS^12,
             :INT!CPU,    ,         :INT!PCTCPU,           :INT!IO,
             :INT!MEMORY,           :INT!BLOCKTM,          :BLOCKID^8,
             :OSPID^10,             :SRVUSER^8,            :CMDNAME^16,
             :CLNTHOST^16,          :PIDC^16,              :TRANNAME^16,
             :PGMNAME^16,           :CLNTUSER^16,          :SRVGROUP^8,
             :INT!NETWKPK,
          :PROCESSNM^30,         :TS!%now_time,
          :DBNAME^90,
          :BLOCKID^24,           :SRVUSER^64,              :CMDNAME^48,
          :TRANNAME^48,             :PGMNAME^48,           :CLNTUSER^48,
          :SRVGROUP^24,             :PROCESSNM^90,
          :NS!STATUSD,        :NS!%current_interval);

cursor LAG;
   INSERT INTO LAG  (X) VALUES (:X);

;;**********************************************************************
;;
;;     KOYPRCS - PROCESS SUMMARY
;;
;;**********************************************************************

cursor KOYPRCS;

       interval 180;
       limit 200;
       empty;
       no_sql;

       pre_cursor OSCPU;
       pre_cursor PRC1;
;;     pre_cursor PRC2;
;;     pre_cursor PRC3;
       pre_cursor KOYPRCD;

       math decimal 0 PCTBLOCK   (KOYV.NUMBLOCK/KOYV.NUMPROCESS)
                                 * 10000;
       math decimal 0 PCTINFECT  (KOYV.NUMINFECT/KOYV.NUMPROCESS)
                                 * 10000;
       math decimal 0 PCTBAD     (KOYV.NUMBAD/KOYV.NUMPROCESS)
                                 * 10000;
       math decimal 0 PCTSTOPPED (KOYV.NUMSTOPPED/KOYV.NUMPROCESS)
                                 * 10000;
       math decimal 0 PCTSLPLCK  (KOYV.NUMSLPLCK/KOYV.NUMPROCESS)
                                 * 10000;
       math decimal 0 PCTSLPOTH  (KOYV.NUMSLPOTH/KOYV.NUMPROCESS)
                                 * 10000;
       math decimal 0 PCTSLEEP   ((KOYV.NUMSLPOTH + KOYV.NUMSLPLCK)
                                 /KOYV.NUMPROCESS) * 10000;

       MATH DECIMAL 0  SRVCPUPCT  KOYV.PCTCPU - KOYV.APPCPUPCT;
       decode SRVCPUPCT < 0, 0;
          
       LOAD  SRVCPUPCT  -> KOYV.SRVCPUPCT;

       INSERT INTO KOYPRCS
             (SERVERID,              HOSTNAME,
              SRVCPUPCT,             APPCPUPCT,             NUMPROCESS,
              NUMBLOCK,              PCTBLOCK,              NUMINFECT,
              PCTINFECT,             NUMBAD,                PCTBAD,
              NUMSTOPPED,            PCTSTOPPED,            NUMSLPLCK,
              PCTSLPLCK,             NUMSLPOTH,             PCTSLPOTH,
              PCTSLEEP,              NUMLOGSUS,             CURRINTL,
              SAMPTIME,              PMDESC,                PMVALUE)
       VALUES
            (:%me^32,               :%machine,
             :INT!SRVCPUPCT,        :INT!KOYV.APPCPUPCT,   :INT!KOYV.NUMPROCESS,
             :INT!KOYV.NUMBLOCK,    :INT!PCTBLOCK,         :INT!KOYV.NUMINFECT,
             :INT!PCTINFECT,        :INT!KOYV.NUMBAD,      :INT!PCTBAD,
             :INT!KOYV.NUMSTOPPED,  :INT!PCTSTOPPED,       :INT!KOYV.NUMSLPLCK,
             :INT!PCTSLPLCK,        :INT!KOYV.NUMSLPOTH,   :INT!PCTSLPOTH,
             :INT!PCTSLEEP,         :INT!KOYV.NUMLOGSUS,   :INT!%current_interval,
             :TS!%now_time,         :KOYV.PMDESC^1,        :KOYV.PMVALUE^1);

;;**********************************************************************
;;
;;     KOYPROBD - PROBLEM DETAILS
;;
;;**********************************************************************

cursor KOYPROBD;

       demand;
       limit 200;
       empty;
       stale 60;
       fetch_exit fetchx2;
       script koyerr -log [KOYV.ERRLOG [KOYV.LOGTIME ;

;;     LOGTIME
;;     00      Messages since startup
;;     01 24   Messages for past hours indicated
;;     >24     Messages since midnight

       decode MAXSEV   < KOYV.MAXSEV, KOYV.MAXSEV;

;;     column_exit MAXSEV r_justify;

       insert_select
              SELECT MSGTIME,
                     MSGAGE,
                     ERRORID,
                     SEVERITY,
                     MAXSEV,
                     SQLSTATE,
                     MSGISSUER,
                     MSGTEXT1,
                     MSGTEXT2,
                     LOGTIME,
                     ERRORLOGSZ,
                     NUMCURR
              FROM   ABCXYZ;

;;     PUT MAX SEVERITY SINCE STARTUP IN VIRTUAL FOR SUMMARY DISPLAY
;;     SEVERITY WILL BE MAXSEV AND BE RETURNED TWICE TO COLLECTOR

       LOAD MAX!MAXSEV            -> KOYV.MAXSEV;

;;     LOAD LAST LOG TIME FETCHED

;;     PUT AGE OF LAST ERROR IN VIRTUAL TABLE FOR SUMMARY DISPLAY

       LOAD MSGAGE                -> KOYV.LASTERRAGE;

;;     PUT MAX SEVERITY IN VIRTUAL TABLE FOR SUMMARY DISPLAY

       LOAD MAX!SEVERITY          -> KOYV.MAXSEV;

;;     PUT MAX SEVERITY IN VIRTUAL TABLE FOR SUMMARY DISPLAY

       LOAD MSGTIME               -> KOYV.MAXSEVTIME
                                     FROM MAX SEVERITY;

;;     PUT SIZE OF ERROR LOG IN VIRTUAL TABLE FOR SUMMARY DISPLAY

       LOAD ERRORLOGSZ            -> KOYV.ERRORLOGSZ;

;;     COUNT NUMBER OF ERRORS PER INTERVAL FOR SUMMARY DISPLAY

       LOAD NUMCURR               -> KOYV.NUMCURR;

;;     COUNT NUMBER OF ERRORS PER INTERVAL FOR COUNT NUMBER OF TOTAL ERROR

       LOAD NUMCURR               -> KOYV.NUMERRORS;

       LOAD COUNT SEVERITY        -> KOYV.NUMOTH
                                     WHERE SEVERITY < '17';

;;     COUNT NUMBER OF ERRORS PER INTERVAL WHERE SEV >= 17

       LOAD COUNT SEVERITY        -> KOYV.NUMSEVG17
                                     WHERE SEVERITY >= '17';

       INSERT INTO KOYPROBD
             (SERVERID,              HOSTNAME,
              MSGTIME,               MSGAGE,                ERRORID,
              SEVERITY,              MAXSEV,                SQLSTATE,
              MSGISSUER,             MSGTEXT1,              MSGTEXT2,
              SAMPTIME,              UERRORID,              UMSGISSUER,
              UMSGTEXT1,             UMSGTEXT2,
              LOGTIME,               ERRORLOGSZ,            NUMCURR)
       VALUES
            (:%me^30,               :%machine,
             :TS!MSGTIME,           :INT!MSGAGE,           :ERRORID^12,
             :SEVERITY^4,           :MAXSEV^2,             :INT!SQLSTATE,
             :MSGISSUER^8,          :MSGTEXT1^60,          :MSGTEXT2^60,
             :TS!%now_time,         :ERRORID^36,           :MSGISSUER^24,
             :MSGTEXT1^180,         :MSGTEXT2^180,
             :NS!LOGTIME,           :NS!ERRORLOGSZ,        :NS!NUMCURR,);


;;**********************************************************************
;;
;;     KOYPROBS - PROBLEM SUMMARY
;;
;;**********************************************************************

cursor KOYPROBS;

       interval 120;
       empty;
       no_sql;

       pre_cursor KOYPROBD;

       math decimal 0 NUMERRORS (KOYV.NUMERRORS + 0);


       LOAD NUMERRORS             -> KOYV.NUMERRORS;

       INSERT INTO KOYPROBS
             (SERVERID,              HOSTNAME,
              LASTERRAGE,            MAXSEV,                MAXSEVTIME,
              MAXSEVCURR,            NUMERRORS,             NUMCURR,
              NUMSEVG17,             NUMOTH,                ERRLOGSZ,
              CURRINTL,              SAMPTIME,              PMDESC,
              PMVALUE)
       VALUES
            (:%me^30,               :%machine,
             :INT!KOYV.LASTERRAGE,  :KOYV.MAXSEV^2,        :TS!KOYV.MAXSEVTIME,
             :KOYV.MAXSEV^2,        :INT!NUMERRORS,        :INT!KOYV.NUMCURR,
             :INT!KOYV.NUMSEVG17,   :INT!KOYV.NUMOTH,      :INT!KOYV.ERRORLOGSZ,
             :INT!%current_interval,:TS!%now_time,         :KOYV.PMDESC^1,
             :KOYV.PMVALUE^1);

;;**********************************************************************
;;
;;     KOYSCFG - CURRENT CONFIGURATION
;;
;;**********************************************************************

cursor KOYSCFG;

       limit 500;
       demand;
       stale 90;

       decode PARMTYPE =  1,'Dynamic';
       decode PARMTYPE default 'Static';

       column_exit PARMTYPE  r_justify;
       column_exit CONFIGVAL r_justify;
       column_exit RUNVALUE  r_justify;
       column_exit MINVAL    r_justify;
       column_exit MAXVAL    r_justify;

       insert_select
              select CONFIGNAME = t2.comment,
                     PARMTYPE   = t1.status,
                     CONFIGVAL  = t2.value,
                     RUNVALUE   = t1.value,
                     MINVAL     = t3.low,
                     MAXVAL     = t3.high
             FROM    master..syscurconfigs t1,
                     master..sysconfigures t2,
                     master..spt_values    t3
             WHERE   t1.config   = t2.config
             and     t1.config   *= t3.number
             and     t3.type      = 'C';

       INSERT INTO KOYCONF
             (SERVERID,              HOSTNAME,
              CONFIGNAME,            PARMTYPE,              CONFIGVAL,
              RUNVALUE,              MINVAL,                MAXVAL,
              SAMPTIME,              UCONFIGNAM,            UCONFIGVAL,
              URUNVALUE)
       VALUES
            (:%me^30,               :%machine,
             :CONFIGNAME^30,        :PARMTYPE^7,           :CONFIGVAL^12,
             :RUNVALUE^12,          :MINVAL^12,            :MAXVAL^12,
             :TS!%now_time,         :CONFIGNAME^90,        :CONFIGVAL^36,
             :RUNVALUE^36);

;;**********************************************************************
;;
;;     KOYSRVR - REMOTE SERVER SUMMARY
;;
;;**********************************************************************

cursor KOYSRVR;

       limit 200;
       interval 60;
       empty;

;;     RSRVCONNLV = ss.srv_conn_level
;;     The above cannot be returned has data type of sensitivity!!!
;;     Plus it says that it is secured!!!!!!!!!!!!!!!!!!!!!!!!!!!1

       insert_select
              SELECT RSRVID      = ss.srvid,
                     RSRVSTATUS  = ss.srvstatus,
                     RSVRNAME    = ss.srvname,
                     RSRVNETNM   = ss.srvnetname,
                     RSRVCONNLV  = 01
              FROM   master..sysservers    ss;

       INSERT INTO KOYSRVR
             (SERVERID,              HOSTNAME,
              RSRVID,                RSVRSTATUS,            RSVRNAME,
              RSRVNETNM,             RSRVCONNLV,            CURRINTL,
              TIMESTAMP)
       VALUES
            (:%me^32,               :%machine,
             :RSRVID^12,            :RSRVSTATUS^8,         :RSVRNAME^12,
             :RSRVNETNM^16,         :INT!RSRVCONNLV,       :INT!%current_interval,
             :TS!%now_time);

;;**********************************************************************
;;
;;     KOYSRVD - SERVER DETAIL
;;
;;**********************************************************************

cursor SRV1;

       demand;
       empty;
       limit 200;
       stale 60;
       fetch_exit fetchx2;
       script koyserv -log [KOYV.ERRLOG;

       math decimal 0 PROCCSZ  (PROCCACH * 2 );
       math decimal 0 SY10CSZ  (DUMMYINT * 2 );
       insert_select
              SELECT DUMMYINT,
                     PROCCACH,
                     ERRORLOG,
                     ERRLOGSZ,
                     SRVSTARTT
              FROM   ABCXYZ;

       LOAD PROCCSZ               -> KOYV.PROCCSZ;
       LOAD SY10CSZ               -> KOYV.SY10CSZ;
;;       LOAD SRVSTARTT             -> KOYV.SRVSTARTT;
       LOAD ERRORLOG              -> KOYV.ERRORLOG;
       LOAD ERRLOGSZ              -> KOYV.ERRLOGSZ;
       LOAD ERRORLOG              -> KOYV.UERRLOG;

       INSERT INTO SRV1
             (PROCCACH,              ERRORLOG,              ERRLOGSZ,
              SY10CSZ,               PROCCSZ,               SRVSTARTT,
              DUMMYINT)
       VALUES
            (:PROCCACH,             :ERRORLOG,             :ERRLOGSZ,
             :SY10CSZ,              :PROCCSZ,              :SRVSTARTT,
             :DUMMYINT);

cursor SRV2;

       stale 60;
       demand;
       conditional_dummy_last_row;

       insert_select
              SELECT DATACHSZ    = value
              FROM   master..syscurconfigs
              WHERE  config = 132;

       INSERT INTO SRV2
             (DATACHSZ)
       VALUES
            (:DATACHSZ);

cursor SRV3;

       limit 200;
       stale 60;
       demand;

       insert_select
         select  SRVTYPE  = substring(@@version,1,
                                charindex("/",@@version)-1),
                 SRVAGE   = datediff (mi,[KOYV.SRVSTARTT,getdate() );

       LOAD  SRVAGE    -> KOYV.SRVAGE;
       INSERT INTO SRV3
             (SRVTYPE,               SRVAGE)
       VALUES
            (:SRVTYPE,            :INT!SRVAGE);

cursor KOYSRVD;

       limit 200;
       stale 60;
       pre_cursor SRV1;
       pre_cursor SRV2;
       pre_cursor SRV3;
       demand;
       empty;

     
       math decimal 0 ACTIVE (1);
       decode ACTIVE = 1, 'Active';
     
       
       math decimal 0 PCTLOCKS (CURLOCKS / KOYV.MAXLOCKS) * 10000;
       math decimal 0 PROCCPCT (KOYV.PROCCPCT) * 100;
       math decimal 0 DATACACH (SRV2.DATACHSZ + KOYV.SY10CSZ);
       math decimal 0 SRVAGE   (SRV3.SRVAGE / 60);

       insert_select
          SELECT SSTARTT=
         substring([KOYV.SRVSTARTT,1,4)+
         substring([KOYV.SRVSTARTT,6,2)+
         substring([KOYV.SRVSTARTT,9,2)+
         substring([KOYV.SRVSTARTT,12,2)+
         substring([KOYV.SRVSTARTT,15,2)+
         substring([KOYV.SRVSTARTT,18,2)+
         "00",
                 CURLOCKS = count(t1.id)
              FROM   master..syslocks   t1;

       LOAD CURLOCKS              -> KOYV.CURLOCKS;
       LOAD ACTIVE                -> KOYV.SRVSTATUS;
       INSERT INTO KOYSRVD
             (SERVERID,              HOSTNAME,
              SRVTYPE,               SRVVERSN,              SRVSTATUS,
              CURLOCKS,              MAXLOCKS,              PCTLOCKS,
              DATACACH,              PROCSSZ,               PROCCPCT,
              SSTARTT,             SRVAGE,                ERRORLOG,
              ERRLOGSZ,              OSTYPE,                OSVERSN,
              SAMPTIME,              UERRLOG,               ACTIVE)
       VALUES
            (:%me^30,               :%machine,
             :SRV3.SRVTYPE^12,      :KOYV.SRVVERSN^8,      :KOYV.SRVSTATUS^8,
             :INT!CURLOCKS,         :INT!KOYV.MAXLOCKS,    :INT!PCTLOCKS,
             :INT!DATACACH,         :INT!KOYV.PROCCSZ,     :INT!PROCCPCT,
             :TS!SSTARTT^16,         :INT!SRVAGE,           :KOYV.ERRORLOG^64,
             :INT!KOYV.ERRLOGSZ,    :KOYV.OSTYPE^8,        :KOYV.OSVERSN^8,
             :TS!%now_time,         :KOYV.UERRLOG^192,    :NS!ACTIVE);

;;**********************************************************************
;;
;;     KOYSRVS - SERVER SUMMARY
;;
;;     NOTE: THIS CURSOR MUST BE EXECUTE BEFORE KOYDEVD (FOR SERVER VERSION)
;;
;;**********************************************************************

cursor KOYSRVS;

       interval 60;
       empty;
       no_sql;

       pre_cursor OSCPU;
       pre_cursor PRC1;
;;     pre_cursor PRC2;
;;     pre_cursor PRC3;
       pre_cursor SRV1;
       pre_cursor SRV2;
       pre_cursor SRV3;
       pre_cursor KOYSRVD;
       math decimal 0 PCTLOCKS (KOYV.CURLOCKS / KOYV.MAXLOCKS)
                               * 10000;
;;     IM#604928, leading blank of server status
       column_exit KOYV.SRVSTATUS l_justify;


       LOAD  PCTLOCKS -> KOYV.PCTLOCKS;

       INSERT INTO KOYSRVS
             (SERVERID,              HOSTNAME,
              SRVTYPE,               SRVSTATUS,             COLSTATUS,
              DATACHSZ,              PROCCHSZ,              PCTLOCKS,
              PCTCPU,                PCTOSCPU,              SRVAGE,
              SRVVERSN,              CURRINTL,              TIMESTAMP,
              PMDESC,                PMVALUE)
       VALUES
            (:%me^30,               :%machine,
             :SRV3.SRVTYPE^12,      :KOYV.SRVSTATUS^12,    :KOYV.COLSTATUS^12,
             :INT!KOYSRVD.DATACACH, :INT!KOYV.PROCCSZ,     :INT!PCTLOCKS,
             :INT!KOYV.PCTCPU,      :INT!KOYV.PCTOSCPU,    :INT!SRV3.SRVAGE,
             :KOYV.SRVVERSN^8,      :INT!%current_interval,:TS!%now_time,
             :KOYV.PMDESC^1,        :KOYV.PMVALUE^1);

;;**********************************************************************
;;
;;     KOYDEVD - DEVICE DETAIL
;;     (KOYSRVS must execute first because of Server Version)
;;
;;**********************************************************************
cursor DEV1;

       stale 10;
       limit 200;
       demand;
       empty;


       column_exit DVTYPE l_justify;

       IF KOYV.VERSION < '15';  
         insert_select
              SELECT DBNAME     = db_name(su.dbid),
                     DEVICE     = dv.name,
                     DVTYPE     = sv.name,
                    'MIRROR'    = dv.mirrorname
              FROM   master..sysusages    su,
                     master..sysdevices   dv,
                     master..spt_values   sv
              WHERE  su.vstart  between dv.low and dv.high
              AND    dv.cntrltype   = 0
              and    sv.type        = 'S'
              and    su.segmap & 7  = sv.number
              GROUP BY su.dbid,dv.name,sv.name,dv.mirrorname;           
       ELSE;
         insert_select
              SELECT DBNAME     = db_name(su.dbid),
                     DEVICE     = dv.name,
                     DVTYPE     = sv.name,
                    'MIRROR'    = dv.mirrorname
              FROM   master..sysusages    su,
                     master..sysdevices   dv,
                     master..spt_values   sv
              WHERE  su.vdevno = dv.vdevno
              AND    dv.cntrltype   = 0
              and    sv.type        = 'S'
              and    su.segmap & 7  = sv.number
              GROUP BY su.dbid,dv.name,sv.name,dv.mirrorname;
       ENDIF;

       INSERT INTO DEV1
             (DBNAME,                DEVICE,                DVTYPE,
              MIRROR,                UDBNAME,               UDEVICE,
              UMIRROR)
       VALUES
            (:DBNAME,               :DEVICE,               :DVTYPE,
            :MIRROR,                :DBNAME^90,            :DEVICE^90,
            :MIRROR^192);

cursor KOYDEVD;

       demand;
       limit 200;
       empty;

       pre_cursor DEV1;

       math decimal 0 DVSIZE  (SIZE / 512);
       math decimal 0 DVFREE  (AVAIL / 512) * 100;
       math decimal 0 PCTDVFREE (AVAIL / SIZE) * 10000;

       IF KOYV.VERSION < '15';  
         insert_select
              SELECT DEVICE     = dv.name,
                     AVAIL      = ((dv.high -dv.low + 1) - sum(su.size)),
                     SIZE       = (dv.high - dv.low + 1),
                     PHYNAME    = dv.phyname
              FROM   master..sysusages    su,
                     master..sysdevices   dv
              WHERE  su.vstart  between dv.low and dv.high
              AND    dv.name   = [DEV1.DEVICE
              AND    dv.cntrltype   = 0
              GROUP BY dv.name,dv.phyname;
       ELSE;  
         insert_select
              SELECT DEVICE     = dv.name,
                     AVAIL      = ((dv.high - dv.low + 1) - (sum(su.size) * (@@maxpagesize / 2048))),
                     SIZE       = (dv.high - dv.low + 1),
                     PHYNAME    = dv.phyname
              FROM   master..sysusages    su,
                     master..sysdevices   dv
              WHERE  su.vdevno = dv.vdevno
              AND    dv.name   = [DEV1.DEVICE
              AND    dv.cntrltype   = 0
              GROUP BY dv.name,dv.phyname;
       ENDIF;

       ITERATE DEV1;

       INSERT INTO KOYDEVD
             (SERVERID,              SRVVERSN,
              HOSTNAME,              DBNAME,                DEVICE,
              DVSIZE,                DVFREE,                PCTDVFREE,
              DVTYPE,                PHYNAME,               MIRROR,
              SAMPTIME,
              UDBNAME,               UDEVICE,               UPHYNAME,
              UMIRROR,               SIZE,                  AVAIL)

       VALUES
            (:%me^30,               :KOYV.SRVVERSN^8,
             :%machine,             :DEV1.DBNAME^30,       :DEV1.DEVICE^30,
             :INT!DVSIZE,           :INT!DVFREE,           :INT!PCTDVFREE,
             :DEV1.DVTYPE^12,       :PHYNAME^64,           :DEV1.MIRROR^64,
             :TS!%now_time,
             :DEV1.DBNAME^90,       :DEV1.DEVICE^90,       :PHYNAME^192,
             :DEV1.MIRROR^192,      :SIZE,                 :AVAIL);


;;**********************************************************************
;;
;;     KOYSTATD - STATISTICS DETAIL
;;
;;**********************************************************************

cursor KOYSTATD;

       demand;
       limit 400;
       stale 300;
       age_to OLDSTATD;
       empty;


       math decimal 0 STATCURR (STATCUM - OLDSTATD.STATCUM);
       math decimal 0 STATAVGS (STATCUM/SECDIFF)*100;
       math decimal 0 CURRINTL (SECDIFF - OLDSTATD.SECDIFF);
       math decimal 0 STATMAX (STATCURR);
       math initial 777.77 decimal 0 STATMIN (STATCUM - OLDSTATD.STATCUM);

       decode STATMAX < OLDSTATD.STATMAX,OLDSTATD.STATMAX;
       decode STATMIN > OLDSTATD.STATMIN and > 0,OLDSTATD.STATMIN;

       insert_select
              set dateformat ymd
              select STATNAME  = 'cpu_busy        ',
                     STATCUM   = @@cpu_busy,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'io_busy         ',
                     STATCUM   = @@io_busy,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'io_busy         ',
                     STATCUM   = @@io_busy,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'idle            ',
                     STATCUM   = @@idle,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'connections     ',
                     STATCUM   = @@connections,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'packets_sent    ',
                     STATCUM   = @@pack_sent,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'packets_received',
                     STATCUM   = @@pack_received,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'packets_error   ',
                     STATCUM   = @@packet_errors,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'physical reads  ',
                     STATCUM   = @@total_read,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'physical writes ',
                     STATCUM   = @@total_write,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              union
              select STATNAME  = 'io errors       ',
                     STATCUM   = @@total_errors,
                     SECDIFF   = datediff (ss,[KOYV.SRVSTARTT,
                                 getdate() )
              order by STATNAME asc;

       BASE OLDSTATD on STATNAME  -> STATNAME;


       LOAD CURRINTL              -> KOYV.CURRINTL;

       LOAD STATCURR              -> KOYV.PCTCPUST
                                     WHERE STATNAME = 'cpu_busy ';

       LOAD STATCURR              -> KOYV.PCTIO
                                     WHERE STATNAME = 'io_busy';

;;       LOAD STATCURR              -> KOYV.LOGONCURR
;;                                     WHERE STATNAME = 'connections ';

       LOAD STATCURR              -> KOYV.PHYRDPSEC
                                     WHERE STATNAME = 'physical reads ';

       LOAD STATCURR              -> KOYV.PHYWRPSEC
                                     WHERE STATNAME = 'physical writes ';

       LOAD STATCURR              -> KOYV.IOERRS
                                     WHERE STATNAME = 'io errors ';


       INSERT INTO KOYSTATD
             (SERVERID,              HOSTNAME,
              STATNAME,              STATCURR,              STATCUM,
              STATAVGS,              STATMAX,               STATMIN,
              SAMPTIME,              SECDIFF,               CURRINTL)
       VALUES
            (:%me^30,               :%machine,
             :STATNAME^32,          :INT!STATCURR,         :INT!STATCUM,
             :INT!STATAVGS,         :INT!STATMAX,          :INT!STATMIN,
             :TS!%now_time,         :SECDIFF,              :CURRINTL);

;;**********************************************************************
;;
;;     Make copy of Detail Stat information
;;
;;**********************************************************************

cursor OLDSTATD;
      INSERT INTO OLDSTATD
            (a)
      VALUES
            (:x);

cursor LOGCURR;
       demand;
       limit 1;

       insert_select
          select INT01=count(*) from master..sysprocesses;

       LOAD INT01 -> KOYV.LOGONCURR;

       INSERT INTO LOGCURR
         (INT01)
       VALUES
         (:INT01);

cursor KOYSTATS;

       interval 60;
       limit 100;
       pre_cursor LOGCURR;
       pre_cursor KOYSTATD;
       empty;
       no_sql;

       math decimal 0 LOGONPCT   (KOYV.LOGONCURR/KOYV.LOGONMAX)*10000;
       math decimal 0 LOGONPSEC  (KOYV.LOGONCURR/KOYV.CURRINTL)*100;
       math decimal 0 DISKIO     (KOYV.PHYRDPSEC + KOYV.PHYWRPSEC);
       math decimal 0 IOERRSCURR (KOYV.IOERRS/KOYV.CURRINTL);
       math decimal 0 IOERRSPCT  (KOYV.IOERRS/KOYV.CURRINTL)*100;


       LOAD  LOGONPCT    -> KOYV.LOGONPCT;
       LOAD  IOERRSCURR  -> KOYV.IOERRSCURR;


       INSERT INTO KOYSTATS
             (SERVERID,              HOSTNAME,
              PCTCPUST,              PCTIO,                 LOGONCURR,
              LOGONPCT,              LOGONPSEC,             LOGONMAX,
              PHYRDPSEC,             PHYWRPSEC,             DISKIO,
              IOERRS,                IOERRSCURR,            IOERRSPCT,
              CURRINTL,              SAMPTIME,              PMDESC,
              PMVALUE)
       VALUES
            (:%me^30,               :%machine,
             :INT!KOYV.PCTCPUST,      :INT!KOYV.PCTIO,       :INT!KOYV.LOGONCURR,
             :INT!LOGONPCT,         :INT!LOGONPSEC,        :INT!KOYV.LOGONMAX,
             :INT!KOYV.PHYRDPSEC,   :INT!KOYV.PHYWRPSEC,   :INT!DISKIO,
             :INT!KOYV.IOERRS,      :INT!IOERRSCURR,       :INT!IOERRSPCT,
             :INT!KOYV.CURRINTL,    :TS!%now_time,         :KOYV.PMDESC^1,
             :KOYV.PMVALUE^1);

;;


end;

