;*****************************************************************************
;*   Licensed Materials - Property of IBM
;*   5724-B96
;*
;*   Copyright IBM Corp. 2005 All Rights Reserved
;*   US Government Users Restricted Rights - Use, duplication or
;*   disclosure restricted by GSA ADP Schedule Contract with
;*   IBM Corp
;******************************************************************************
;;
;;*****************************************************************
;;* The following TRACE commands can be with the collector:      **
;;* trace_all  - activates tracing on all cursors                **
;;* trace      - activates tracing for specific cursor           **
;;* tracem     - activates math tracing for this cursor          **
;;* tracec     - activates tracing for decodes on this cursor    **
;;* show_row   - displays prepared rows for this cursor          **
;;*****************************************************************
;;
;;trace_all;
;;
;;trace KOYSRVRE;
;;show_row KOYSRVRE;
;;
;;trace KOYSRVR;
;;show_row KOYSRVR;
;;
;;trace      HART;
;;tracem     HART;
;;traced     HART;
;;show_row   HART;
;;
;;trace      KOYV;
;;tracem     KOYV;
;;traced     KOYV;
;;show_row   KOYV;
;;
;;trace      HART0;
;;tracem     HART0;
;;traced     HART0;
;;show_row   HART0;
;;
;;trace      HART1;
;;tracem     HART1;
;;traced     HART1;
;;show_row   HART1;
;;
;;trace      HART2;
;;tracem     HART2;
;;traced     HART2;
;;show_row   HART2;
;;
;;trace      HART3;
;;tracem     HART3;
;;traced     HART3;
;;show_row   HART3;
;;
;;trace      HART4;
;;tracem     HART4;
;;traced     HART4;
;;show_row   HART4;
;;
;;trace      HART5;
;;tracem     HART5;
;;traced     HART5;
;;show_row   HART5;
;;
;;trace      START;
;;tracem     START;
;;traced     START;
;;show_row   START;
;;
;;trace      SETERRLG;
;;tracem     SETERRLG;
;;traced     SETERRLG;
;;show_row   SETERRLG;
;;
;;trace      SERVPID;
;;tracem     SERVPID;
;;traced     SERVPID;
;;show_row   SERVPID;
;;
;;
;;trace      SYSCHECK;
;;tracem     SYSCHECK;
;;traced     SYSCHECK;
;;show_row   SYSCHECK;
;;
;;trace      MINITCK;
;;tracem     MINITCK;
;;traced     MINITCK;
;;show_row   MINITCK;
;;
;;trace      SYSMONCK;
;;tracem     SYSMONCK;
;;traced     SYSMONCK;
;;show_row   SYSMONCK;
;;
;;trace      PREINIT;
;;tracem     PREINIT;
;;traced     PREINIT;
;;show_row   PREINIT;
;;
;;trace    KOYMINIT;
;;tracem   KOYMINIT;
;;traced   KOYMINIT;
;;show_row KOYMINIT;
;;
;;trace    STPSTRT;
;;tracem   STPSTRT;
;;traced   STPSTRT;
;;show_row STPSTRT;
;;
;;trace      SYSMON;
;;tracem     SYSMON;
;;traced     SYSMON;
;;show_row   SYSMON;
;;
;;trace      CACHEMAP;
;;traced     CACHEMAP;
;;tracem     CACHEMAP;
;;show_row   CACHEMAP;
;;
;;trace      SYSDEV;
;;traced     SYSDEV;
;;tracem     SYSDEV;
;;show_row   SYSDEV;
;;
;;trace      SYSCCONF;
;;tracem     SYSCCONF;
;;traced     SYSCCONF;
;;show_row   SYSCCONF;
;;
;;trace      KOYENGD;
;;tracem     KOYENGD;
;;traced     KOYENGD;
;;show_row   KOYENGD;
;;
;;
;;trace      KOYENGS;
;;tracem     KOYENGS;
;;traced     KOYENGS;
;;show_row   KOYENGS;
;;
;;trace      KOYVSTAT;
;;tracem     KOYVSTAT;
;;traced     KOYVSTAT;
;;show_row   KOYVSTAT;
;;
;;trace      DBD1;
;;tracem     DBD1;
;;traced     DBD1;
;;show_row   DBD1;
;;
;;trace      DBD2;
;;tracem     DBD2;
;;traced     DBD2;
;;show_row   DBD2;
;;
;;trace      DBD3;
;;tracem     DBD3;
;;traced     DBD3;
;;show_row   DBD3;
;;
;;trace      KOYDBD;
;;tracem     KOYDBD;
;;traced     KOYDBD;
;;show_row   KOYDBD;
;;
;;trace      KOYDBS;
;;tracem     KOYDBS;
;;traced     KOYDBS;
;;show_row   KOYDBS;
;;
;;trace      DEV1;
;;tracem     DEV1;
;;traced     DEV1;
;;show_row   DEV1;
;;
;;trace      KOYDEVD;
;;tracem     KOYDEVD;
;;traced     KOYDEVD;
;;show_row   KOYDEVD;
;;
;;
;;trace      KOYLOCK;
;;tracem     KOYLOCK;
;;traced     KOYLOCK;
;;show_row   KOYLOCK;
;;
;;  trace      KOYLOCKS;
;;  tracem     KOYLOCKS;
;;  traced     KOYLOCKS;
;;  show_row   KOYLOCKS;
;;
;;trace      BLOCOUNT;
;;tracem     BLOCOUNT;
;;traced     BLOCOUNT;
;;show_row   BLOCOUNT;
;;
;;trace      PROCOUNT;
;;tracem     PROCOUNT;
;;traced     PROCOUNT;
;;show_row   PROCOUNT;
;;
;;trace      GETADDR;
;;tracem     GETADDR;
;;traced     GETADDR;
;;show_row   GETADDR;
;;
;;trace      KOYSQL;
;;tracem     KOYSQL;
;;traced     KOYSQL;
;;show_row   KOYSQL;
;;
;;trace      OSCPU;
;;tracem     OSCPU;
;;traced     OSCPU;
;;show_row   OSCPU;
;;
;;trace      PRC1;
;;tracem     PRC1;
;;traced     PRC1;
;;show_row   PRC1;
;;
;;trace      PRC2;
;;tracem     PRC2;
;;traced     PRC2;
;;show_row   PRC2;
;;
;;trace      PRC3;
;;tracem     PRC3;
;;traced     PRC3;
;;show_row   PRC3;
;;
;;  trace      KOYPRCD;
;;  tracem     KOYPRCD;
;;  traced     KOYPRCD;
;;  show_row   KOYPRCD;
;;
;;trace      KOYPRCS;
;;tracem     KOYPRCS;
;;traced     KOYPRCS;
;;show_row   KOYPRCS;
;;
;;trace      KOYPROBD;
;;tracem     KOYPROBD;
;;traced     KOYPROBD;
;;show_row   KOYPROBD;
;;
;;trace      KOYPROBS;
;;tracem     KOYPROBS;
;;traced     KOYPROBS;
;;show_row   KOYPROBS;
;;
;;trace      KOYSCFG;
;;tracem     KOYSCFG;
;;traced     KOYSCFG;
;;show_row   KOYSCFG;
;;
;;trace      KOYSRVR;
;;tracem     KOYSRVR;
;;traced     KOYSRVR;
;;show_row   KOYSRVR;
;;
;;trace      SRV1;
;;tracem     SRV1;
;;traced     SRV1;
;;show_row   SRV1;
;;
;;trace      SRV2;
;;tracem     SRV2;
;;traced     SRV2;
;;show_row   SRV2;
;;
;;trace      SRV3;
;;tracem     SRV3;
;;traced     SRV3;
;;show_row   SRV3;
;;
;;trace      KOYSRVD;
;;tracem     KOYSRVD;
;;traced     KOYSRVD;
;;show_row   KOYSRVD;
;;
;;trace      KOYSRVS;
;;tracem     KOYSRVS;
;;traced     KOYSRVS;
;;show_row   KOYSRVS;
;;
;;trace      KOYSTATD;
;;tracem     KOYSTATD;
;;traced     KOYSTATD;
;;show_row   KOYSTATD;
;;
;;trace      KOYSTATS;
;;tracem     KOYSTATS;
;;traced     KOYSTATS;
;;show_row   KOYSTATS;
;;
;;trace      OLDSTATD;
;;tracem     OLDSTATD;
;;traced     OLDSTATD;
;;show_row   OLDSTATD;
 end;
